import React, { Component, Fragment } from 'react';
import { Collapse, Input, Checkbox, Select, DatePicker, TimePicker } from 'antd';
import 'antd/lib/input/style/css';
import 'antd/lib/select/style/css';
import 'antd/lib/switch/style/css';
import G6 from '@antv/g6/src';
import moment from 'moment';
import { library } from '@fortawesome/fontawesome-svg-core';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faShare, faCopy, faPaste, faTrashAlt, faSearchPlus, faSearchMinus, faCompress, faExpand, faLayerGroup } from '@fortawesome/free-solid-svg-icons';
import _ from 'lodash';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".index_root__NkeuW {\n  width: 100%;\n  height: 100%;\n  background-color: #fff;\n  display: block;\n}\n.index_toolbar__HjD87 {\n  width: 100%;\n  padding: 8px 0;\n  background-color: #fff;\n  border: 1px solid #E9E9E9;\n  box-shadow: 0 8px 12px 0 rgba(0, 52, 107, 0.04);\n}\n.index_toolbar__HjD87 .index_command__16-c6 {\n  display: inline-block;\n  margin: 0 6px;\n  line-height: 27px;\n  border: 1px solid rgba(2, 2, 2, 0);\n  border-radius: 2px;\n}\n.index_toolbar__HjD87 .index_command__16-c6 svg {\n  margin: 0 6px;\n}\n.index_toolbar__HjD87 .index_command__16-c6:nth-of-type(1) {\n  margin-left: 24px;\n}\n.index_toolbar__HjD87 .index_command__16-c6:hover {\n  border: 1px solid #E9E9E9;\n  cursor: pointer;\n}\n.index_toolbar__HjD87 .index_separator__3Stfv {\n  margin: 4px;\n  border-left: 1px solid #E9E9E9;\n}\n.index_toolbar__HjD87 .index_icon-select__2TnlT.index_disable__1mlPN {\n  background: #EEE;\n}\n.index_toolbar__HjD87 .index_disable__1mlPN {\n  color: rgba(0, 0, 0, 0.25);\n}\n.index_toolbar__HjD87 .index_disable__1mlPN:hover {\n  border: 1px solid rgba(2, 2, 2, 0);\n  cursor: default;\n}\n.index_itemPanel__1yGXR {\n  float: left;\n  width: 10%;\n  background: #f0f2f5;\n  overflow-y: auto;\n  border-left: 1px solid #E9E9E9;\n  border-bottom: 1px solid #E9E9E9;\n}\n.index_itemPanel__1yGXR .ant-collapse {\n  border: 0;\n}\n.index_itemPanel__1yGXR .ant-collapse .ant-collapse-item {\n  border-bottom: 0;\n}\n.index_itemPanel__1yGXR .ant-collapse .ant-collapse-item .ant-collapse-header {\n  text-align: left;\n  border: 1px solid #E9E9E9;\n  border-left: 0;\n}\n.index_itemPanel__1yGXR .ant-collapse .ant-collapse-item .ant-collapse-header[aria-expanded=false] {\n  border-bottom: 0;\n}\n.index_itemPanel__1yGXR .ant-collapse .ant-collapse-item:first-child .ant-collapse-header {\n  border-top: 0;\n}\n.index_itemPanel__1yGXR .ant-collapse .ant-collapse-item:last-child .ant-collapse-header {\n  border-bottom: 1px solid #E9E9E9;\n}\n.index_itemPanel__1yGXR .ant-collapse .ant-collapse-item .ant-collapse-content {\n  border-top: 0;\n  background: #f0f2f5;\n  text-align: center;\n}\n.index_itemPanel__1yGXR img {\n  width: 92px;\n  height: 96px;\n  padding: 4px;\n  border: 1px solid rgba(0, 0, 0, 0);\n  border-radius: 2px;\n}\n.index_itemPanel__1yGXR img:hover {\n  border: 1px solid #ccc;\n  cursor: move;\n}\n.index_canvasPanel__1QWM8 {\n  -webkit-box-flex: 0;\n          flex: 0 0 auto;\n  float: left;\n  width: 70%;\n  background-color: #fff;\n  border-bottom: 1px solid #E9E9E9;\n}\n.index_detailPanel__2ziu3 {\n  height: 100%;\n  background: #f0f2f5;\n  -webkit-box-flex: 0;\n          flex: 0 0 auto;\n  float: left;\n  width: 20%;\n  border-right: 1px solid #E9E9E9;\n  border-bottom: 1px solid #E9E9E9;\n}\n.index_panelTitle__BUkCr {\n  height: 32px;\n  padding-left: 12px;\n  color: #000;\n  line-height: 28px;\n  background: #EBEEF2;\n  border-bottom: 1px solid #DCE3E8;\n}\n.index_panelBody__2rppQ .index_panelRow__3rN1B {\n  display: inline-block;\n  font-size: 12px;\n  width: 100%;\n  padding: 5px 12px;\n}\n.index_panelBody__2rppQ .index_panelRow__3rN1B .index_panelInput__3IV3E {\n  margin-top: 3px;\n  padding: 4px 11px;\n  width: 100%;\n  height: 32px;\n  line-height: 1.5;\n  color: rgba(0, 0, 0, 0.65);\n  background-color: #fff;\n  background-image: none;\n  border: 1px solid #d9d9d9;\n  border-radius: 4px;\n  -webkit-transition: all 0.3s;\n  transition: all 0.3s;\n}\n.index_panelBody__2rppQ .index_panelRow__3rN1B .index_panelInput__3IV3E:hover {\n  border-color: #1890ff;\n}\n.index_contextmenu__309Aq {\n  display: none;\n  width: 200px;\n  margin: 0;\n  color: #000;\n  font-size: 12px;\n  background: white;\n  box-shadow: 0 1px 4px rgba(0, 0, 0, 0.25);\n}\n.index_contextmenu__309Aq .index_disable__1mlPN {\n  color: rgba(0, 0, 0, 0.25);\n}\n.index_contextmenu__309Aq .index_command__16-c6 {\n  box-sizing: content-box;\n  height: 12px;\n  padding: 8px;\n}\n.index_contextmenu__309Aq .index_command__16-c6:hover {\n  background: #E6F7FF;\n  cursor: pointer;\n}\n.index_contextmenu__309Aq .index_command__16-c6.index_disable__1mlPN:hover {\n  background: none;\n  cursor: default;\n}\n.index_contextmenu__309Aq span:nth-of-type(1) {\n  float: left;\n}\n.index_contextmenu__309Aq span:nth-of-type(2) {\n  float: right;\n}\n";
var styles = {"root":"index_root__NkeuW","toolbar":"index_toolbar__HjD87","command":"index_command__16-c6","separator":"index_separator__3Stfv","icon-select":"index_icon-select__2TnlT","disable":"index_disable__1mlPN","itemPanel":"index_itemPanel__1yGXR","canvasPanel":"index_canvasPanel__1QWM8","detailPanel":"index_detailPanel__2ziu3","panelTitle":"index_panelTitle__BUkCr","panelBody":"index_panelBody__2rppQ","panelRow":"index_panelRow__3rN1B","panelInput":"index_panelInput__3IV3E","contextmenu":"index_contextmenu__309Aq","iconSelect":"index_icon-select__2TnlT"};
styleInject(css);

function getShapeName(clazz) {
  switch (clazz) {
    case 'start':
      return 'start-node';

    case 'end':
      return 'end-node';

    case 'gateway':
      return 'gateway-node';

    case 'timerStart':
      return 'timer-start-node';

    case 'messageStart':
      return 'message-start-node';

    case 'signalStart':
      return 'signal-start-node';

    case 'userTask':
      return 'user-task-node';

    case 'scriptTask':
      return 'script-task-node';

    case 'mailTask':
      return 'mail-task-node';

    case 'javaTask':
      return 'java-task-node';

    case 'receiveTask':
      return 'receive-task-node';

    case 'timerCatch':
      return 'timer-catch-node';

    case 'messageCatch':
      return 'message-catch-node';

    case 'signalCatch':
      return 'signal-catch-node';

    default:
      return 'task-node';
  }
}

var en = {
  'label': 'Label',
  'hideIcon': 'Hide Icon',
  'userTask': 'User Task',
  'userTask.assignType': 'Assign Type',
  'userTask.assignType.placeholder': 'Select a assign type',
  'userTask.assignType.person': 'Person',
  'userTask.assignType.person.title': 'Assign Person',
  'userTask.assignType.person.placeholder': 'Select assign person',
  'userTask.assignType.persongroup': 'Person Group',
  'userTask.assignType.persongroup.title': 'Assign Person Group',
  'userTask.assignType.persongroup.placeholder': 'Select assign person group',
  'userTask.assignType.custom': 'Custom Java Class',
  'userTask.assignType.custom.title': 'Java Class Name',
  'userTask.dueDate': 'Due Date',
  'userTask.dueDate.placeholder': 'Select date',
  'userTask.counterSign': 'CounterSign',
  'scriptTask': 'Script Task',
  'scriptTask.script': 'Script',
  'javaTask': 'Java Task',
  'javaTask.javaClass': 'Java Class Name',
  'mailTask': 'Mail Task',
  'mailTask.to': 'To',
  'mailTask.subject': 'Subject',
  'mailTask.content': 'Content',
  'receiveTask': 'Receive Task',
  'receiveTask.waitState': 'Wait State',
  'receiveTask.stateValue': 'State Value',
  'timerEvent': 'Timer Event',
  'timerEvent.cycle': 'Cycle',
  'timerEvent.cycle.placeholder': 'Select time',
  'timerEvent.duration': 'Duration',
  'messageEvent': 'Message Event',
  'messageEvent.message': 'Message',
  'signalEvent': 'Signal Event',
  'signalEvent.signal': 'Signal',
  'exclusiveGateway': 'Gateway',
  'sequenceFlow': 'Sequence Flow',
  'sequenceFlow.expression': 'Expression',
  'sequenceFlow.seq': 'Sequence',
  'sequenceFlow.reverse': 'Reverse',
  'startEvent': 'Start Event',
  'endEvent': 'End Event',
  'start': 'Start Events',
  'end': 'End Events',
  'gateway': 'Gateway',
  'task': 'Task',
  'catch': 'Catching Event'
};

var zh = {
  'label': '标题',
  'hideIcon': '隐藏图标',
  'userTask': '审批节点',
  'userTask.assignType': '指派类型',
  'userTask.assignType.placeholder': '选择一个类型',
  'userTask.assignType.person': '人员',
  'userTask.assignType.person.title': '审批人',
  'userTask.assignType.person.placeholder': '选择审批人',
  'userTask.assignType.persongroup': '人员组',
  'userTask.assignType.persongroup.title': '审批组',
  'userTask.assignType.persongroup.placeholder': '选择审批组',
  'userTask.assignType.custom': '自定义类',
  'userTask.assignType.custom.title': '类名',
  'userTask.dueDate': '到期时间',
  'userTask.dueDate.placeholder': '请选择日期',
  'userTask.counterSign': '会签',
  'scriptTask': '脚本节点',
  'scriptTask.script': '脚本',
  'javaTask': '自定义类节点',
  'javaTask.javaClass': '类名',
  'mailTask': '邮件节点',
  'mailTask.to': '收件人',
  'mailTask.subject': '标题',
  'mailTask.content': '内容',
  'receiveTask': '接收节点',
  'receiveTask.waitState': '等待属性',
  'receiveTask.stateValue': '等待值',
  'timerEvent': '定时节点',
  'timerEvent.cycle': '循环时间',
  'timerEvent.cycle.placeholder': '请选择时间',
  'timerEvent.duration': '持续时间',
  'messageEvent': '消息节点',
  'messageEvent.message': '消息名',
  'signalEvent': '信号节点',
  'signalEvent.signal': '信号名',
  'exclusiveGateway': '网关节点',
  'sequenceFlow': '连接线',
  'sequenceFlow.expression': '条件表达式',
  'sequenceFlow.seq': '序号',
  'sequenceFlow.reverse': '反向',
  'startEvent': '开始节点',
  'endEvent': '结束节点',
  'start': '开始事件',
  'end': '结束事件',
  'gateway': '网关',
  'task': '活动',
  'catch': '捕获事件'
};

var locale = {
  en: en,
  zh: zh
};

var faLayerUp = {
  prefix: 'fas',
  iconName: 'layer-up',
  icon: [160, 160, [], '', 'M11.25,57.19l51.25,25L110,34.69l-50-25ZM61.25.94l57.5,28.75c2.5,1.25,3.75,3.75,2.5,6.25A1.22,1.22,0,0,1,120,37.19L67.5,90.94a13.59,13.59,0,0,1-6.25,1.25l-57.5-30c-2.5,0-3.75-3.75-2.5-6.25A1.22,1.22,0,0,1,2.5,54.69L56.25.94C56.25-.31,58.75-.31,61.25.94ZM112.5,72.19c-1.25,0-1.25-2.5-1.25-5a1.22,1.22,0,0,1,1.25-1.25l-3.75,3.75Zm1.25,0Zm0-6.25Zm-20-3.75,3.75-7.5,20,11.25c2.5,1.25,3.75,3.75,2.5,5,0,1.25-1.25,1.25-1.25,2.5l-52.5,55a2.34,2.34,0,0,1-3.75,0l-60-30C0,97.19,0,94.69,0,92.19c0-1.25,1.25-1.25,1.25-2.5L22.5,67.19l7.5,7.5L11.25,93.44l50,26.25L107.5,70.94ZM65,120.94H61.25l5,7.5L60,122.19l2.5-2.5,2.5,1.25ZM7.5,97.19h0a5.5,5.5,0,0,0-1.25-6.25l5,2.5Zm0-6.25c1.25,1.25,2.5,2.5,1.25,5A1.22,1.22,0,0,1,7.5,97.19l3.75-3.75Zm-1.25,0Zm5,2.5,50,26.25L107.5,70.94,93.75,62.19l3.75-7.5,20,11.25c2.5,1.25,3.75,3.75,2.5,5,0,1.25-1.25,1.25-1.25,2.5l-52.5,55a2.34,2.34,0,0,1-3.75,0l-60-30C0,97.19,0,94.69,0,92.19c0-1.25,1.25-1.25,1.25-2.5L22.5,67.19l7.5,7.5ZM65,120.94H61.25l5,7.5L60,122.19l2.5-2.5,2.5,1.25Zm47.5-55h0c-1.25,2.5,0,5,0,6.25l-3.75-2.5Zm1.25,0Zm0,6.25ZM108.75,102.19l5,2.5c-1.25,0-2.5-2.5-2.5-5a1.22,1.22,0,0,1,1.25-1.25Zm6.25,3.75Zm-1.25-7.5Zm-5,3.75-12.5-6.25,3.75-7.5,16.25,8.75c2.5,1.25,3.75,3.75,2.5,5,0,1.25-1.25,1.25-1.25,2.5l-52.5,55a2.34,2.34,0,0,1-3.75,0l-58.75-30c-2.5,0-2.5-2.5-2.5-5,0-1.25,1.25-1.25,1.25-2.5l20-20,6.25,6.25L11.25,124.69l50,26.25,47.5-48.75ZM65,153.44H61.25l5,7.5L60,154.69l2.5-2.5,2.5,1.25ZM7.5,129.69h0a5.5,5.5,0,0,0-1.25-6.25l5,2.5Zm-1.25-6.25Zm1.25,0c1.25,1.25,2.5,2.5,1.25,5a1.22,1.22,0,0,1-1.25,1.25l3.75-3.75Zm-1.25,0Zm5,2.5,50,26.25,46.25-48.75L95,97.19l3.75-7.5L115,98.44c2.5,1.25,3.75,3.75,2.5,5,0,1.25-1.25,1.25-1.25,2.5l-52.5,55a2.34,2.34,0,0,1-3.75,0l-58.75-30C0,129.69,0,127.19,0,124.69c0-1.25,1.25-1.25,1.25-2.5l20-20,6.25,6.25-16.25,17.5ZM65,153.44H61.25l5,7.5L60,154.69l2.5-2.5,2.5,1.25Zm47.5-55h0a5.5,5.5,0,0,0,1.25,6.25l-5-2.5,3.75-3.75Zm1.25,0Zm1.25,7.5Zm32.5-66.25L120,77.19h17.5v2.5c0,20-6.25,37.5-16.25,52.5,20-10,35-31.25,35-55H175l-27.5-37.5Z']
};
var faLayerDown = {
  prefix: 'fas',
  iconName: 'layer-down',
  icon: [160, 160, [], '', 'M60,9.69,11.25,57.19l51.25,25L110,34.69ZM61.25.94l57.5,28.75c2.5,1.25,3.75,3.75,2.5,6.25A1.22,1.22,0,0,1,120,37.19L67.5,90.94a13.59,13.59,0,0,1-6.25,1.25l-57.5-30c-2.5,0-3.75-3.75-2.5-6.25A1.22,1.22,0,0,1,2.5,54.69L56.25.94C56.25-.31,58.75-.31,61.25.94ZM112.5,72.19c-1.25,0-1.25-2.5-1.25-5a1.22,1.22,0,0,1,1.25-1.25l-3.75,3.75Zm1.25,0Zm0-6.25Zm-20-3.75,3.75-7.5,20,11.25c2.5,1.25,3.75,3.75,2.5,5,0,1.25-1.25,1.25-1.25,2.5l-52.5,55a2.34,2.34,0,0,1-3.75,0l-60-30C0,97.19,0,94.69,0,92.19c0-1.25,1.25-1.25,1.25-2.5L22.5,67.19l7.5,7.5L11.25,93.44l50,26.25L107.5,70.94ZM65,120.94H61.25l5,7.5L60,122.19l2.5-2.5,2.5,1.25ZM7.5,97.19h0a5.5,5.5,0,0,0-1.25-6.25l5,2.5Zm0-6.25c1.25,1.25,2.5,2.5,1.25,5A1.22,1.22,0,0,1,7.5,97.19l3.75-3.75Zm-1.25,0Zm5,2.5,50,26.25L107.5,70.94,93.75,62.19l3.75-7.5,20,11.25c2.5,1.25,3.75,3.75,2.5,5,0,1.25-1.25,1.25-1.25,2.5l-52.5,55a2.34,2.34,0,0,1-3.75,0l-60-30C0,97.19,0,94.69,0,92.19c0-1.25,1.25-1.25,1.25-2.5L22.5,67.19l7.5,7.5ZM65,120.94H61.25l5,7.5L60,122.19l2.5-2.5,2.5,1.25Zm47.5-55h0c-1.25,2.5,0,5,0,6.25l-3.75-2.5Zm1.25,0Zm0,6.25ZM108.75,102.19l5,2.5c-1.25,0-2.5-2.5-2.5-5a1.22,1.22,0,0,1,1.25-1.25Zm6.25,3.75Zm-1.25-7.5Zm-5,3.75-12.5-6.25,3.75-7.5,16.25,8.75c2.5,1.25,3.75,3.75,2.5,5,0,1.25-1.25,1.25-1.25,2.5l-52.5,55a2.34,2.34,0,0,1-3.75,0l-58.75-30c-2.5,0-2.5-2.5-2.5-5,0-1.25,1.25-1.25,1.25-2.5l20-20,6.25,6.25L11.25,124.69l50,26.25,47.5-48.75ZM65,153.44H61.25l5,7.5L60,154.69l2.5-2.5,2.5,1.25ZM7.5,129.69h0a5.5,5.5,0,0,0-1.25-6.25l5,2.5Zm-1.25-6.25Zm1.25,0c1.25,1.25,2.5,2.5,1.25,5a1.22,1.22,0,0,1-1.25,1.25l3.75-3.75Zm-1.25,0Zm5,2.5,50,26.25,46.25-48.75L95,97.19l3.75-7.5L115,98.44c2.5,1.25,3.75,3.75,2.5,5,0,1.25-1.25,1.25-1.25,2.5l-52.5,55a2.34,2.34,0,0,1-3.75,0l-58.75-30C0,129.69,0,127.19,0,124.69c0-1.25,1.25-1.25,1.25-2.5l20-20,6.25,6.25-16.25,17.5ZM65,153.44H61.25l5,7.5L60,154.69l2.5-2.5,2.5,1.25Zm47.5-55h0a5.5,5.5,0,0,0,1.25,6.25l-5-2.5,3.75-3.75Zm1.25,0Zm1.25,7.5Zm32.5,26.25L120,94.69h17.5v-2.5c0-20-6.25-37.5-16.25-52.5,20,10,35,31.25,35,55H175Z']
};
var faUndo = {
  prefix: 'fas',
  iconName: 'undo',
  icon: [1000, 800, [], '', 'M292.28,252.12A19.33,19.33,0,0,0,273,271.32v286.4a25.58,25.58,0,0,0,25.6,25.6H585.08a19.16,19.16,0,0,0,13.6-32.72L497.08,449c65.76-81.44,166.4-133.6,279.2-133.6,136.24,0,254.72,76,315.36,188C1055.08,321.8,894.68,185,702.28,185c-128.08,0-241.92,60.56-314.56,154.64l-81.84-81.92a19.18,19.18,0,0,0-13.6-5.6Z']
};
var faRedo = {
  prefix: 'fas',
  iconName: 'redo',
  icon: [1000, 1000, [], '', 'M999.2 353.9c-6.4 0-12.5 2.5-17 7L879.9 463.3C789.1 345.7 646.8 270 486.7 270 246.2 270 45.7 441 0 668c75.8-140 223.9-235 394.2-235 141 0 266.8 65.2 349 167l-127 127c-9.4 9.4-9.4 24.6 0 33.9 4.5 4.5 10.6 7 17 7h358.1c17.7 0 32-14.3 32-32v-358c-0.1-13.2-10.8-24-24.1-24z']
};

var Util = require('@antv/g6/src/util');

var Command =
/*#__PURE__*/
function () {
  function Command() {
    _classCallCheck(this, Command);
  }

  _createClass(Command, [{
    key: "getDefaultCfg",
    value: function getDefaultCfg() {
      return {
        _command: {
          zoomDelta: .1,
          queue: [],
          current: 0,
          clipboard: []
        }
      };
    }
  }, {
    key: "get",
    value: function get(key) {
      return this._cfgs[key];
    }
  }, {
    key: "set",
    value: function set(key, val) {
      this._cfgs[key] = val;
    }
  }, {
    key: "initPlugin",
    value: function initPlugin(graph) {
      var _this = this;

      this._cfgs = this.getDefaultCfg();
      this.list = [];
      this.queue = [];
      this.initCommands();

      graph.getCommands = function () {
        return _this.get('_command').queue;
      };

      graph.getCurrentCommand = function () {
        var c = _this.get('_command');

        return c.queue[c.current - 1];
      };

      graph.executeCommand = function (name, cfg) {
        _this.execute(name, graph, cfg);
      };

      graph.commandEnable = function (name) {
        return _this.enable(name, graph);
      };
    }
  }, {
    key: "registerCommand",
    value: function registerCommand(name, cfg) {
      if (this[name]) {
        Util.mix(this[name], cfg);
      } else {
        var cmd = Util.mix({}, {
          name: name,
          shortcutCodes: [],
          queue: true,
          executeTimes: 1,
          init: function init() {},
          enable: function enable() {
            return true;
          },
          execute: function execute(graph) {
            this.snapShot = graph.save();
            this.selectedItems = graph.get('selectedItems');
            this.method && (Util.isString(this.method) ? graph[this.method]() : this.method(graph));
          },
          back: function back(graph) {
            graph.read(this.snapShot);
            graph.set('selectedItems', this.selectedItems);
          }
        }, cfg);
        this[name] = cmd;
        this.list.push(cmd);
      }
    }
  }, {
    key: "execute",
    value: function execute(name, graph, cfg) {
      var cmd = Util.mix({}, this[name], cfg);
      var manager = this.get('_command');

      if (cmd.enable(graph)) {
        cmd.init();

        if (cmd.queue) {
          manager.queue.splice(manager.current, manager.queue.length - manager.current, cmd);
          manager.current++;
        }
      }

      graph.emit('beforecommandexecute', {
        command: cmd
      });
      cmd.execute(graph);
      graph.emit('aftercommandexecute', {
        command: cmd
      });
      return cmd;
    }
  }, {
    key: "enable",
    value: function enable(name, graph) {
      return this[name].enable(graph);
    }
  }, {
    key: "destroyPlugin",
    value: function destroyPlugin() {
      this._events = null;
      this._cfgs = null;
      this.list = [];
      this.queue = [];
      this.destroyed = true;
    }
  }, {
    key: "initCommands",
    value: function initCommands() {
      var cmdPlugin = this;
      cmdPlugin.registerCommand('add', {
        enable: function enable() {
          return this.type && this.addModel;
        },
        execute: function execute(graph) {
          var item = graph.add(this.type, this.addModel);
          if (this.executeTimes === 1) this.addId = item.get('id');
        },
        back: function back(graph) {
          graph.remove(this.addId);
        }
      });
      cmdPlugin.registerCommand('update', {
        enable: function enable() {
          return this.itemId && this.updateModel;
        },
        execute: function execute(graph) {
          var item = graph.findById(this.itemId);

          if (item) {
            if (this.executeTimes === 1) this.originModel = Util.mix({}, item.getModel());
            graph.update(item, this.updateModel);
          }
        },
        back: function back(graph) {
          var item = graph.findById(this.itemId);
          graph.update(item, this.originModel);
        }
      });
      cmdPlugin.registerCommand('delete', {
        enable: function enable(graph) {
          var mode = graph.getCurrentMode();
          var selectedItems = graph.get('selectedItems');
          return mode === 'edit' && selectedItems && selectedItems.length > 0;
        },
        method: function method(graph) {
          var selectedItems = graph.get('selectedItems');
          graph.emit('beforedelete', {
            items: selectedItems
          });

          if (selectedItems && selectedItems.length > 0) {
            selectedItems.forEach(function (i) {
              return graph.remove(i);
            });
          }

          graph.emit('afterdelete', {
            items: selectedItems
          });
        },
        shortcutCodes: ['Delete', 'Backspace']
      });
      cmdPlugin.registerCommand('redo', {
        queue: false,
        enable: function enable(graph) {
          var mode = graph.getCurrentMode();
          var manager = cmdPlugin.get('_command');
          return mode === 'edit' && manager.current < manager.queue.length;
        },
        execute: function execute(graph) {
          var manager = cmdPlugin.get('_command');
          var cmd = manager.queue[manager.current];
          cmd && cmd.execute(graph);
          manager.current++;
        },
        shortcutCodes: [['metaKey', 'shiftKey', 'z'], ['ctrlKey', 'shiftKey', 'z']]
      });
      cmdPlugin.registerCommand('undo', {
        queue: false,
        enable: function enable(graph) {
          var mode = graph.getCurrentMode();
          return mode === 'edit' && cmdPlugin.get('_command').current > 0;
        },
        execute: function execute(graph) {
          var manager = cmdPlugin.get('_command');
          var cmd = manager.queue[manager.current - 1];

          if (cmd) {
            cmd.executeTimes++;
            cmd.back(graph);
          }

          manager.current--;
        },
        shortcutCodes: [['metaKey', 'z'], ['ctrlKey', 'z']]
      });
      cmdPlugin.registerCommand('copy', {
        queue: false,
        enable: function enable(graph) {
          var mode = graph.getCurrentMode();
          var items = graph.get('selectedItems');
          return mode === 'edit' && items && items.length > 0;
        },
        method: function method(graph) {
          var manager = cmdPlugin.get('_command');
          manager.clipboard = [];
          var items = graph.get('selectedItems');

          if (items && items.length > 0) {
            var item = graph.findById(items[0]);

            if (item) {
              manager.clipboard.push({
                type: item.get('type'),
                model: item.getModel()
              });
            }
          }
        }
      });
      cmdPlugin.registerCommand('paste', {
        enable: function enable(graph) {
          var mode = graph.getCurrentMode();
          return mode === 'edit' && cmdPlugin.get('_command').clipboard.length > 0;
        },
        method: function method(graph) {
          var manager = cmdPlugin.get('_command');
          this.pasteData = Util.clone(manager.clipboard[0]);
          var addModel = this.pasteData.model;
          addModel.x && (addModel.x += 10);
          addModel.y && (addModel.y += 10);
          delete addModel.id;
          var item = graph.add(this.pasteData.type, addModel);
          item.toFront();
        }
      });
      cmdPlugin.registerCommand('zoomIn', {
        queue: false,
        enable: function enable(graph) {
          var zoom = graph.getZoom();
          var maxZoom = graph.get('maxZoom');
          var minZoom = graph.get('minZoom');
          return zoom <= maxZoom && zoom >= minZoom;
        },
        execute: function execute(graph) {
          var manager = cmdPlugin.get('_command');
          var maxZoom = graph.get('maxZoom');
          var zoom = graph.getZoom();
          this.originZoom = zoom;
          var currentZoom = zoom + manager.zoomDelta;
          if (currentZoom > maxZoom) currentZoom = maxZoom;
          graph.zoomTo(currentZoom);
        },
        back: function back(graph) {
          graph.zoomTo(this.originZoom);
        },
        shortcutCodes: [['metaKey', '='], ['ctrlKey', '=']]
      });
      cmdPlugin.registerCommand('zoomOut', {
        queue: false,
        enable: function enable(graph) {
          var zoom = graph.getZoom();
          var maxZoom = graph.get('maxZoom');
          var minZoom = graph.get('minZoom');
          return zoom <= maxZoom && zoom >= minZoom;
        },
        execute: function execute(graph) {
          var manager = cmdPlugin.get('_command');
          var minZoom = graph.get('minZoom');
          var zoom = graph.getZoom();
          this.originZoom = zoom;
          var currentZoom = zoom - manager.zoomDelta;
          if (currentZoom < minZoom) currentZoom = minZoom;
          graph.zoomTo(currentZoom);
        },
        back: function back(graph) {
          graph.zoomTo(this.originZoom);
        },
        shortcutCodes: [['metaKey', '-'], ['ctrlKey', '-']]
      });
      cmdPlugin.registerCommand('resetZoom', {
        queue: false,
        execute: function execute(graph) {
          var zoom = graph.getZoom();
          this.originZoom = zoom;
          graph.zoomTo(1);
        },
        back: function back(graph) {
          graph.zoomTo(this.originZoom);
        }
      });
      cmdPlugin.registerCommand('toFront', {
        queue: false,
        enable: function enable(graph) {
          var items = graph.get('selectedItems');
          return items && items.length > 0;
        },
        execute: function execute(graph) {
          var items = graph.get('selectedItems');

          if (items && items.length > 0) {
            var item = graph.findById(items[0]);
            item.toFront();
            graph.paint();
          }
        },
        back: function back(graph) {}
      });
      cmdPlugin.registerCommand('toBack', {
        queue: false,
        enable: function enable(graph) {
          var items = graph.get('selectedItems');
          return items && items.length > 0;
        },
        execute: function execute(graph) {
          var items = graph.get('selectedItems');

          if (items && items.length > 0) {
            var item = graph.findById(items[0]);
            item.toBack();
            graph.paint();
          }
        },
        back: function back(graph) {}
      });
    }
  }]);

  return Command;
}();

var deepMix = require('@antv/util/lib/deep-mix');

var each = require('@antv/util/lib/each');

var wrapBehavior = require('@antv/util/lib/event/wrap-behavior');

var modifyCSS = require('@antv/util/lib/dom/modify-css');

var Toolbar =
/*#__PURE__*/
function () {
  function Toolbar(cfgs) {
    _classCallCheck(this, Toolbar);

    this._cfgs = deepMix(this.getDefaultCfg(), cfgs);
  }

  _createClass(Toolbar, [{
    key: "getDefaultCfg",
    value: function getDefaultCfg() {
      return {
        container: null
      };
    }
  }, {
    key: "get",
    value: function get(key) {
      return this._cfgs[key];
    }
  }, {
    key: "set",
    value: function set(key, val) {
      this._cfgs[key] = val;
    }
  }, {
    key: "initPlugin",
    value: function initPlugin(graph) {
      var self = this;
      this.set('graph', graph);
      var events = self.getEvents();
      var bindEvents = {};
      each(events, function (v, k) {
        var event = wrapBehavior(self, v);
        bindEvents[k] = event;
        graph.on(k, event);
      });
      this._events = bindEvents;
      this.initEvents();
      this.updateToolbar();
    }
  }, {
    key: "getEvents",
    value: function getEvents() {
      return {
        afteritemselected: 'updateToolbar',
        aftercommandexecute: 'updateToolbar'
      };
    }
  }, {
    key: "initEvents",
    value: function initEvents() {
      var graph = this.get('graph');
      var parentNode = this.get('container');
      each(parentNode.children, function (child, i) {
        if (child.hasAttribute('data-command')) {
          var cmdName = child.getAttribute('data-command');
          child.addEventListener('click', function (e) {
            graph.commandEnable(cmdName) && graph.executeCommand(cmdName);
          });
        }
      });
    }
  }, {
    key: "updateToolbar",
    value: function updateToolbar() {
      var graph = this.get('graph');
      var parentNode = this.get('container');
      each(parentNode.children, function (child, i) {
        if (child.hasAttribute('data-command')) {
          var cmdName = child.getAttribute('data-command');

          if (graph.commandEnable(cmdName)) {
            modifyCSS(child, {
              cursor: 'pointer'
            });
            child.children[0].setAttribute('color', '#666');
          } else {
            modifyCSS(child, {
              cursor: 'default'
            });
            child.children[0].setAttribute('color', '#bfbfbf');
          }
        }
      });
    }
  }, {
    key: "destroyPlugin",
    value: function destroyPlugin() {
      this.get('canvas').destroy();
      var container = this.get('container');
      container.parentNode.removeChild(container);
    }
  }]);

  return Toolbar;
}();

var deepMix$1 = require('@antv/util/lib/deep-mix');

var each$1 = require('@antv/util/lib/each');

var wrapBehavior$1 = require('@antv/util/lib/event/wrap-behavior');

var createDOM = require('@antv/util/lib/dom/create-dom');

var AddItemPanel =
/*#__PURE__*/
function () {
  function AddItemPanel(cfgs) {
    _classCallCheck(this, AddItemPanel);

    this._cfgs = deepMix$1(this.getDefaultCfg(), cfgs);
  }

  _createClass(AddItemPanel, [{
    key: "getDefaultCfg",
    value: function getDefaultCfg() {
      return {
        container: null
      };
    }
  }, {
    key: "get",
    value: function get(key) {
      return this._cfgs[key];
    }
  }, {
    key: "set",
    value: function set(key, val) {
      this._cfgs[key] = val;
    }
  }, {
    key: "initPlugin",
    value: function initPlugin(graph) {
      var parentNode = this.get('container');
      var ghost = createDOM('<img src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7"' + ' style="opacity:0"/>');
      var children = parentNode.querySelectorAll('div > div > .ant-collapse-content > div > img[data-item]');
      each$1(children, function (child, i) {
        var addModel = new Function("return " + child.getAttribute('data-item'))();
        child.addEventListener('dragstart', function (e) {
          e.dataTransfer.setDragImage(ghost, 0, 0);
          graph.set('onDragAddNode', true);
          graph.set('addModel', addModel);
        });
        child.addEventListener('dragend', function (e) {
          graph.emit('canvas:mouseup', e);
          graph.set('onDragAddNode', false);
          graph.set('addModel', null);
        });
      });
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.get('canvas').destroy();
      var container = this.get('container');
      container.parentNode.removeChild(container);
    }
  }]);

  return AddItemPanel;
}();

var deepMix$2 = require('@antv/util/lib/deep-mix');

var each$2 = require('@antv/util/lib/each');

var wrapBehavior$2 = require('@antv/util/lib/event/wrap-behavior');

var createDOM$1 = require('@antv/util/lib/dom/create-dom');

var modifyCSS$1 = require('@antv/util/lib/dom/modify-css');

var CanvasPanel =
/*#__PURE__*/
function () {
  function CanvasPanel(cfgs) {
    _classCallCheck(this, CanvasPanel);

    this._cfgs = deepMix$2(this.getDefaultCfg(), cfgs);
  }

  _createClass(CanvasPanel, [{
    key: "getDefaultCfg",
    value: function getDefaultCfg() {
      return {
        container: null
      };
    }
  }, {
    key: "get",
    value: function get(key) {
      return this._cfgs[key];
    }
  }, {
    key: "set",
    value: function set(key, val) {
      this._cfgs[key] = val;
    }
  }, {
    key: "initPlugin",
    value: function initPlugin(graph) {
      var parentNode = this.get('container');
      parentNode.addEventListener('dragover', function (e) {
        graph.emit('canvas:mousemove', e);
      });
      parentNode.addEventListener('dragleave', function (e) {
        graph.emit('canvas:mouseleave', e);
      });
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.get('canvas').destroy();
      var container = this.get('container');
      container.parentNode.removeChild(container);
    }
  }]);

  return CanvasPanel;
}();

var editorStyle = {
  nodeActivedOutterStyle: {
    lineWidth: 0
  },
  groupSelectedOutterStyle: {
    stroke: '#E0F0FF',
    lineWidth: 2
  },
  nodeSelectedOutterStyle: {
    stroke: '#E0F0FF',
    lineWidth: 2
  },
  edgeActivedStyle: {
    stroke: '#1890FF',
    strokeOpacity: .92
  },
  nodeActivedStyle: {
    fill: '#F3F9FF',
    stroke: '#1890FF'
  },
  groupActivedStyle: {
    stroke: '#1890FF'
  },
  edgeSelectedStyle: {
    lineWidth: 2,
    strokeOpacity: .92,
    stroke: '#A3B1BF'
  },
  nodeSelectedStyle: {
    fill: '#F3F9FF',
    stroke: '#1890FF',
    fillOpacity: .4
  },
  groupSelectedStyle: {
    stroke: '#1890FF',
    fillOpacity: .92
  },
  nodeStyle: {
    stroke: '#CED4D9',
    fill: '#FFFFFF',
    shadowOffsetX: 0,
    shadowOffsetY: 4,
    shadowBlur: 10,
    shadowColor: 'rgba(13, 26, 38, 0.08)',
    lineWidth: 1,
    radius: 4,
    strokeOpacity: .7
  },
  edgeStyle: {
    stroke: '#A3B1BF',
    strokeOpacity: .92,
    lineWidth: 1,
    lineAppendWidth: 8,
    endArrow: true
  },
  groupBackgroundPadding: [40, 10, 10, 10],
  groupLabelOffsetX: 10,
  groupLabelOffsetY: 10,
  edgeLabelStyle: {
    fill: '#666',
    textAlign: 'center',
    textBaseline: 'middle'
  },
  edgeLabelRectPadding: 4,
  edgeLabelRectStyle: {
    fill: 'white'
  },
  nodeLabelStyle: {
    fill: '#666',
    textAlign: 'center',
    textBaseline: 'middle'
  },
  groupStyle: {
    stroke: '#CED4D9',
    radius: 4
  },
  groupLabelStyle: {
    fill: '#666',
    textAlign: 'left',
    textBaseline: 'top'
  },
  multiSelectRectStyle: {
    fill: '#1890FF',
    fillOpacity: .08,
    stroke: '#1890FF',
    opacity: .1
  },
  dragNodeHoverToGroupStyle: {
    stroke: '#1890FF',
    lineWidth: 2
  },
  dragNodeLeaveFromGroupStyle: {
    stroke: '#BAE7FF',
    lineWidth: 2
  },
  anchorPointStyle: {
    radius: 3.5,
    fill: '#fff',
    stroke: '#1890FF',
    lineAppendWidth: 12
  },
  anchorHotsoptStyle: {
    radius: 12,
    fill: '#1890FF',
    fillOpacity: .25
  },
  anchorHotsoptActivedStyle: {
    radius: 14
  },
  anchorPointHoverStyle: {
    radius: 4,
    fill: '#1890FF',
    fillOpacity: 1,
    stroke: '#1890FF'
  },
  nodeControlPointStyle: {
    radius: 4,
    fill: '#fff',
    shadowBlur: 4,
    shadowColor: '#666'
  },
  edgeControlPointStyle: {
    radius: 6,
    symbol: 'square',
    lineAppendWidth: 6,
    fillOpacity: 0,
    strokeOpacity: 0
  },
  nodeSelectedBoxStyle: {
    stroke: '#C2C2C2'
  },
  cursor: {
    panningCanvas: '-webkit-grabbing',
    beforePanCanvas: '-webkit-grab',
    hoverNode: 'move',
    hoverEffectiveAnchor: 'crosshair',
    hoverEdge: 'default',
    hoverGroup: 'move',
    hoverUnEffectiveAnchor: 'default',
    hoverEdgeControllPoint: 'crosshair',
    multiSelect: 'crosshair'
  },
  nodeDelegationStyle: {
    stroke: '#1890FF',
    fill: '#1890FF',
    fillOpacity: .08,
    lineDash: [4, 4],
    radius: 4,
    lineWidth: 1
  },
  edgeDelegationStyle: {
    stroke: '#1890FF',
    lineDash: [4, 4],
    lineWidth: 1
  }
};

var SingleShapeMixin = require('@antv/g6/src/shape/single-shape-mixin');

var Util$1 = require('@antv/g6/src/util');

function registerAnchor (G6) {
  G6.Shape.registerFactory('anchor', {
    defaultShapeType: 'marker'
  });
  G6.Shape.registerAnchor('single-anchor', Util$1.mix({}, SingleShapeMixin, {
    itemType: 'anchor',
    drawShape: function drawShape(cfg, group) {
      var shapeType = this.shapeType;
      var style = this.getShapeStyle(cfg);
      var shape = group.addShape(shapeType, {
        attrs: style
      });
      return shape;
    },
    setState: function setState(name, value, item) {
      if (name === 'active-anchor') {
        if (value) {
          this.update({
            style: _objectSpread({}, editorStyle.anchorPointHoverStyle)
          }, item);
        } else {
          this.update({
            style: _objectSpread({}, editorStyle.anchorPointStyle)
          }, item);
        }
      }
    }
  }));
  G6.Shape.registerAnchor('marker', {
    shapeType: 'marker'
  }, 'single-anchor');
}

var Item = require('@antv/g6/src/item/item');

var dashArray = [[0, 1], [0, 2], [1, 2], [0, 1, 1, 2], [0, 2, 1, 2], [1, 2, 1, 2], [2, 2, 1, 2], [3, 2, 1, 2], [4, 2, 1, 2]];
var interval = 9;
var lineDash = [4, 2, 1, 2];
function registerNode (G6) {
  G6.registerNode('flow-node', {
    icon: null,
    selectedColor: '#eee',
    unSelectedColor: '#f9f9f9',
    borderColor: '#bbb',
    drawAnchor: function drawAnchor(group) {
      var bbox = group.get('children')[0].getBBox();
      this.getAnchorPoints().forEach(function (p, i) {
        var anchorContainer = group.addGroup();
        var anchor = new Item({
          type: 'anchor',
          group: anchorContainer,
          capture: false,
          index: i,
          isActived: false,
          model: {
            style: _objectSpread({
              x: bbox.minX + bbox.width * p[0],
              y: bbox.minY + bbox.height * p[1]
            }, editorStyle.anchorPointStyle, {
              cursor: editorStyle.cursor.hoverEffectiveAnchor
            })
          }
        });
        anchor.isAnchor = true;
        anchor.toFront();
        var hotpot;

        anchor.showHotpot = function () {
          hotpot = anchorContainer.addShape('marker', {
            attrs: _objectSpread({
              x: bbox.minX + bbox.width * p[0],
              y: bbox.minY + bbox.height * p[1]
            }, editorStyle.anchorHotsoptStyle)
          });
          hotpot.toFront();
          anchor.getKeyShape().toFront();
        };

        anchor.setActived = function () {
          anchor.update({
            style: _objectSpread({}, editorStyle.anchorPointHoverStyle)
          });
        };

        anchor.clearActived = function () {
          anchor.update({
            style: _objectSpread({}, editorStyle.anchorPointStyle)
          });
        };

        anchor.setHotspotActived = function (act) {
          hotpot && (act ? hotpot.attr(editorStyle.anchorHotsoptActivedStyle) : hotpot.attr(editorStyle.anchorHotsoptStyle));
        };

        group.anchorShapes.push(anchorContainer);

        group.getAllAnchors = function () {
          return group.anchorShapes.map(function (c) {
            c.filter(function (a) {
              return a.isAnchor;
            });
          });
        };

        group.getAnchor = function (i) {
          return group.anchorShapes.filter(function (a) {
            return a.get('index') === i;
          });
        };
      });
    },
    drawShape: function drawShape(cfg, group) {
      var _this = this;

      var shapeType = this.shapeType;
      var style = this.getShapeStyle(cfg);
      var shape = group.addShape(shapeType, {
        attrs: _objectSpread({}, style)
      });

      if (cfg.icon) {
        var attrs = {
          x: style.x + 2,
          y: style.y + 2,
          width: 14,
          height: 14
        };

        if (shapeType === 'circle') {
          attrs = {
            x: style.x - style.r + 6,
            y: style.y - style.r + 6,
            width: 18,
            height: 18
          };
        } else if (shapeType === 'path') {
          attrs = {
            x: -10,
            y: -8,
            width: 20,
            height: 20
          };
        }

        group.icon = group.addShape('image', {
          attrs: _objectSpread({
            img: cfg.icon
          }, attrs)
        });
      }

      group.anchorShapes = [];

      group.showAnchor = function (group) {
        _this.drawAnchor(group);
      };

      group.clearAnchor = function (group) {
        group.anchorShapes && group.anchorShapes.forEach(function (a) {
          return a.remove();
        });
        group.anchorShapes = [];
      };

      group.clearHotpotActived = function (group) {
        group.anchorShapes && group.anchorShapes.forEach(function (a) {
          if (a.isAnchor) a.setHotspotActived(false);
        });
      };

      return shape;
    },
    setState: function setState(name, value, item) {
      var group = item.getContainer();

      if (name === 'show-anchor') {
        if (value) {
          group.showAnchor(group);
        } else {
          group.clearAnchor(group);
        }
      } else if (name === 'selected') {
        var rect = group.getChildByIndex(0);

        if (value) {
          rect.attr('fill', item.getModel().selectedColor);
        } else {
          rect.attr('fill', item.getModel().unSelectedColor);
        }
      } else if (name === 'hover') {
        var _rect = group.getChildByIndex(0);

        var text = group.getChildByIndex(1);

        if (value) {
          _rect.attr('cursor', editorStyle.cursor.hoverNode);

          if (text) text.attr('cursor', editorStyle.cursor.hoverNode);
        } else {
          _rect.attr('cursor', 'default');

          if (text) text.attr('cursor', 'default');
        }
      }
    },
    getAnchorPoints: function getAnchorPoints() {
      return [[0.5, 0], // top
      [1, 0.5], // right
      [0.5, 1], // bottom
      [0, 0.5]];
    },
    runAnimate: function runAnimate(cfg, group) {
      if (cfg.active) {
        var totalArray = [];
        var index = 0;
        var shape = group.getFirst();
        shape.animate({
          onFrame: function onFrame(ratio) {
            for (var i = 0; i < 9; i += interval) {
              totalArray = totalArray.concat(lineDash);
            }

            var cfg = {
              lineDash: dashArray[index].concat(totalArray)
            };
            index = (index + 1) % interval;
            return cfg;
          },
          repeat: true
        }, 5000);
      }
    },
    afterDraw: function afterDraw(cfg, group) {
      this.runAnimate(cfg, group);
    },
    afterUpdate: function afterUpdate(cfg, group) {
      var icon = group.get('group').icon;

      if (cfg.hideIcon && icon && icon.get('visible')) {
        icon.hide();
      } else if (icon && !icon.get('visible')) {
        icon.show();
      }
    },
    initStyle: function initStyle(cfg) {
      cfg.selectedColor = this.selectedColor;
      cfg.unSelectedColor = this.unSelectedColor;
      cfg.icon = this.icon;
      return cfg;
    }
  }, 'single-shape');
  G6.registerNode('task-node', {
    shapeType: 'rect',
    selectedColor: '#95D6FB',
    unSelectedColor: '#E7F7FE',
    borderColor: '#1890FF',
    getShapeStyle: function getShapeStyle(cfg) {
      cfg.size = [80, 44];
      cfg = this.initStyle(cfg);
      var width = cfg.size[0];
      var height = cfg.size[1];

      var style = _objectSpread({
        x: 0 - width / 2,
        y: 0 - height / 2,
        width: width,
        height: height
      }, editorStyle.nodeStyle, {
        fill: cfg.unSelectedColor,
        stroke: this.borderColor
      });

      return style;
    }
  }, 'flow-node');
  G6.registerNode('gateway-node', {
    shapeType: 'path',
    selectedColor: '#8CE8DE',
    unSelectedColor: '#E8FEFA',
    borderColor: '#13C2C2',
    labelPosition: 'bottom',
    getShapeStyle: function getShapeStyle(cfg) {
      cfg.size = [40, 40];
      cfg = this.initStyle(cfg);
      var width = cfg.size[0];
      var height = cfg.size[1];
      var gap = 4;

      var style = _objectSpread({
        path: [['M', 0 - gap, 0 - height / 2 + gap], ['Q', 0, 0 - height / 2, gap, 0 - height / 2 + gap], ['L', width / 2 - gap, 0 - gap], ['Q', width / 2, 0, width / 2 - gap, gap], ['L', gap, height / 2 - gap], ['Q', 0, height / 2, 0 - gap, height / 2 - gap], ['L', -width / 2 + gap, gap], ['Q', -width / 2, 0, -width / 2 + gap, 0 - gap], ['Z'] // close
        ]
      }, editorStyle.nodeStyle, {
        fill: cfg.unSelectedColor,
        stroke: this.borderColor
      });

      return style;
    },
    afterDraw: function afterDraw(cfg, group) {
      group.icon = group.addShape('path', {
        attrs: {
          path: [['M', -6, -6], ['L', 6, 6], ['Z'], ['M', 6, -6], ['L', -6, 6], ['Z'] // close
          ],
          lineWidth: 2,
          fill: this.borderColor,
          stroke: this.borderColor
        }
      });
      this.runAnimate(cfg, group);
    }
  }, 'flow-node');
  G6.registerNode('start-node', {
    shapeType: 'circle',
    selectedColor: '#FCD49A',
    unSelectedColor: '#FEF7E8',
    borderColor: '#FA8C16',
    labelPosition: 'bottom',
    getShapeStyle: function getShapeStyle(cfg) {
      cfg.size = [30, 30];
      cfg = this.initStyle(cfg);
      var width = cfg.size[0];

      var style = _objectSpread({
        x: 0,
        y: 0,
        r: width / 2
      }, editorStyle.nodeStyle, {
        fill: cfg.unSelectedColor,
        stroke: this.borderColor
      });

      return style;
    },
    afterDraw: function afterDraw(cfg, group) {
      group.icon = group.addShape('path', {
        attrs: {
          path: [['M', -4, -6], ['L', 6, 0], ['L', -4, 6], ['Z'] // close
          ],
          fill: this.borderColor,
          stroke: this.borderColor
        }
      });
    },
    getAnchorPoints: function getAnchorPoints() {
      return [[0.5, 0], // top
      [1, 0.5], // right
      [0.5, 1]];
    }
  }, 'flow-node');
  G6.registerNode('end-node', {
    shapeType: 'circle',
    selectedColor: '#CFD49A',
    unSelectedColor: '#EFF7E8',
    borderColor: '#F5222D',
    labelPosition: 'bottom',
    getShapeStyle: function getShapeStyle(cfg) {
      cfg.size = [30, 30];
      cfg = this.initStyle(cfg);
      var width = cfg.size[0];

      var style = _objectSpread({
        x: 0,
        y: 0,
        r: width / 2
      }, editorStyle.nodeStyle, {
        fill: cfg.unSelectedColor,
        stroke: this.borderColor
      });

      return style;
    },
    afterDraw: function afterDraw(cfg, group) {
      group.icon = group.addShape('path', {
        attrs: {
          path: [['M', -4, -4], ['L', 4, -4], ['L', 4, 4], ['L', -4, 4], ['Z'] // close
          ],
          fill: this.borderColor,
          stroke: this.borderColor
        }
      });
    },
    getAnchorPoints: function getAnchorPoints() {
      return [[0.5, 0], // top
      [0.5, 1], // bottom
      [0, 0.5]];
    }
  }, 'flow-node');
  G6.registerNode('catch-node', {
    shapeType: 'path',
    selectedColor: '#FCD49A',
    unSelectedColor: '#FEF7E8',
    borderColor: '#FA8C16',
    labelPosition: 'bottom',
    getShapeStyle: function getShapeStyle(cfg) {
      cfg.size = [50, 30];
      cfg = this.initStyle(cfg);
      var width = cfg.size[0];
      var height = cfg.size[1];

      var style = _objectSpread({
        path: [['M', 0, -height / 3], ['L', width / 2, -height / 3], ['L', 0, height / 3 * 2], ['L', -width / 2, -height / 3], ['Z'] // close
        ]
      }, editorStyle.nodeStyle, {
        fill: cfg.unSelectedColor,
        stroke: this.borderColor
      });

      return style;
    },
    getAnchorPoints: function getAnchorPoints() {
      return [[0.5, 0], // top
      [0.8, 0.38], // right
      [0.5, 1], // bottom
      [0.2, 0.38]];
    }
  }, 'flow-node');
  G6.registerNode('user-task-node', {
    icon: require('../assets/icons/icon_user.svg'),
    selectedColor: '#95D6FB',
    unSelectedColor: '#E7F7FE',
    borderColor: '#1890FF'
  }, 'task-node');
  G6.registerNode('script-task-node', {
    icon: require('../assets/icons/icon_script.svg'),
    selectedColor: '#FFE7BA',
    unSelectedColor: '#FFF7E6',
    borderColor: '#FFA940'
  }, 'task-node');
  G6.registerNode('java-task-node', {
    icon: require('../assets/icons/icon_java.svg'),
    selectedColor: '#FFCCC7',
    unSelectedColor: '#FFF1F0',
    borderColor: '#FF4D4F'
  }, 'task-node');
  G6.registerNode('mail-task-node', {
    icon: require('../assets/icons/icon_mail.svg'),
    selectedColor: '#D9F7BE',
    unSelectedColor: '#F6FFED',
    borderColor: '#73D13D'
  }, 'task-node');
  G6.registerNode('receive-task-node', {
    icon: require('../assets/icons/icon_receive.svg'),
    selectedColor: '#ffd6e7',
    unSelectedColor: '#fff0f6',
    borderColor: '#ff85c0'
  }, 'task-node');
  G6.registerNode('timer-start-node', {
    icon: require('../assets/icons/icon_timer.svg'),
    afterDraw: function afterDraw(cfg, group) {
      this.runAnimate(cfg, group);
    }
  }, 'start-node');
  G6.registerNode('message-start-node', {
    icon: require('../assets/icons/icon_message.svg'),
    afterDraw: function afterDraw(cfg, group) {
      this.runAnimate(cfg, group);
    }
  }, 'start-node');
  G6.registerNode('signal-start-node', {
    icon: require('../assets/icons/icon_signal.svg'),
    afterDraw: function afterDraw(cfg, group) {
      this.runAnimate(cfg, group);
    }
  }, 'start-node');
  G6.registerNode('timer-catch-node', {
    icon: require('../assets/icons/icon_timer.svg')
  }, 'catch-node');
  G6.registerNode('signal-catch-node', {
    icon: require('../assets/icons/icon_signal.svg')
  }, 'catch-node');
  G6.registerNode('message-catch-node', {
    icon: require('../assets/icons/icon_message.svg')
  }, 'catch-node');
}

function registerEdge (G6) {
  G6.registerEdge('flow-polyline-round', {
    drawShape: function drawShape(cfg, group) {
      this.group = group;
      var shapeStyle = this.getShapeStyle(cfg);
      var shape = group.addShape('path', {
        className: 'edge-shape',
        attrs: shapeStyle
      });
      return shape;
    },
    drawLabel: function drawLabel(cfg, group) {
      var labelCfg = cfg.labelCfg || {};
      var labelStyle = this.getLabelStyle(cfg, labelCfg, group);
      var label = group.addShape('text', {
        attrs: labelStyle
      });
      var labelBBox = label.getBBox();
      group.addShape('rect', {
        className: 'edge-labelRect',
        attrs: {
          x: labelBBox.x - editorStyle.edgeLabelRectPadding / 2,
          y: labelBBox.y - editorStyle.edgeLabelRectPadding / 2,
          width: labelBBox.width + editorStyle.edgeLabelRectPadding,
          height: labelBBox.height + editorStyle.edgeLabelRectPadding,
          fill: '#fff',
          stroke: '#fff'
        }
      });
      group.toBack();
      label.toFront();
      return label;
    },
    afterUpdate: function afterUpdate(cfg, item) {
      var label = item.getContainer().findByClassName('edge-label');
      var labelRect = item.getContainer().findByClassName('edge-labelRect');

      if (label) {
        var labelBBox = label.getBBox();
        labelRect.attr({
          x: labelBBox.x - editorStyle.edgeLabelRectPadding / 2,
          y: labelBBox.y - editorStyle.edgeLabelRectPadding / 2,
          width: labelBBox.width + editorStyle.edgeLabelRectPadding,
          height: labelBBox.height + editorStyle.edgeLabelRectPadding
        });
      }
    },
    getShapeStyle: function getShapeStyle(cfg) {
      cfg = this.getPathPoints(cfg);
      var startPoint = cfg.startPoint;
      var endPoint = cfg.endPoint;
      var controlPoints = this.getControlPoints(cfg);
      var points = [startPoint];

      if (controlPoints) {
        points = points.concat(controlPoints);
      }

      points.push(endPoint);
      var path = this.getPath(points);
      var style = editorStyle.edgeStyle;
      if (cfg.reverse) style = _objectSpread({}, style, {
        lineDash: [1, 3]
      });else style = _objectSpread({}, style, {
        lineDash: null
      });
      return _objectSpread({
        path: path
      }, style, {
        endArrow: {
          path: 'M 0,0 L -10,-4 S -8 0,-10 4 Z'
        }
      });
    },
    getPath: function getPath(points) {
      var path = [];

      for (var i = 0; i < points.length; i++) {
        var point = points[i];

        if (i === 0) {
          path.push(['M', point.x, point.y]);
        } else if (i === points.length - 1) {
          path.push(['L', point.x, point.y]);
        } else {
          var prevPoint = points[i - 1];
          var nextPoint = points[i + 1];
          var cornerLen = 5;

          if (Math.abs(point.y - prevPoint.y) > cornerLen || Math.abs(point.x - prevPoint.x) > cornerLen) {
            if (prevPoint.x === point.x) {
              path.push(['L', point.x, point.y > prevPoint.y ? point.y - cornerLen : point.y + cornerLen]);
            } else if (prevPoint.y === point.y) {
              path.push(['L', point.x > prevPoint.x ? point.x - cornerLen : point.x + cornerLen, point.y]);
            }
          }

          var yLen = Math.abs(point.y - nextPoint.y);
          var xLen = Math.abs(point.x - nextPoint.x);

          if (yLen > 0 && yLen < cornerLen) {
            cornerLen = yLen;
          } else if (xLen > 0 && xLen < cornerLen) {
            cornerLen = xLen;
          }

          if (prevPoint.x !== nextPoint.x && nextPoint.x === point.x) {
            path.push(['Q', point.x, point.y, point.x, point.y > nextPoint.y ? point.y - cornerLen : point.y + cornerLen]);
          } else if (prevPoint.y !== nextPoint.y && nextPoint.y === point.y) {
            path.push(['Q', point.x, point.y, point.x > nextPoint.x ? point.x - cornerLen : point.x + cornerLen, point.y]);
          }
        }
      }

      return path;
    },
    getControlPoints: function getControlPoints(cfg) {
      if (!cfg.sourceNode) {
        return cfg.controlPoints;
      }

      return this.polylineFinding(cfg.sourceNode, cfg.targetNode, cfg.startPoint, cfg.endPoint, 15);
    },
    setState: function setState(name, value, item) {
      var group = item.getContainer();
      var path = group.getChildByIndex(0);

      if (name === 'selected') {
        if (value) {
          path.attr('lineWidth', editorStyle.edgeSelectedStyle.lineWidth);
          path.attr('stroke', editorStyle.edgeStyle.stroke);
        } else {
          path.attr('lineWidth', editorStyle.edgeStyle.lineWidth);
        }
      } else if (name === 'hover') {
        if (value) path.attr('stroke', editorStyle.edgeActivedStyle.stroke);else path.attr('stroke', editorStyle.edgeStyle.stroke);
      }
    },
    getExpandedBBox: function getExpandedBBox(bbox, offset) {
      return 0 === bbox.width && 0 === bbox.height ? bbox : {
        centerX: bbox.centerX,
        centerY: bbox.centerY,
        minX: bbox.minX - offset,
        minY: bbox.minY - offset,
        maxX: bbox.maxX + offset,
        maxY: bbox.maxY + offset,
        height: bbox.height + 2 * offset,
        width: bbox.width + 2 * offset
      };
    },
    getExpandedPort: function getExpandedPort(bbox, point) {
      return Math.abs(point.x - bbox.centerX) / bbox.width > Math.abs(point.y - bbox.centerY) / bbox.height ? {
        x: point.x > bbox.centerX ? bbox.maxX : bbox.minX,
        y: point.y
      } : {
        x: point.x,
        y: point.y > bbox.centerY ? bbox.maxY : bbox.minY
      };
    },
    combineBBoxes: function combineBBoxes(sBBox, tBBox) {
      var minX = Math.min(sBBox.minX, tBBox.minX),
          minY = Math.min(sBBox.minY, tBBox.minY),
          maxX = Math.max(sBBox.maxX, tBBox.maxX),
          maxY = Math.max(sBBox.maxY, tBBox.maxY);
      return {
        centerX: (minX + maxX) / 2,
        centerY: (minY + maxY) / 2,
        minX: minX,
        minY: minY,
        maxX: maxX,
        maxY: maxY,
        height: maxY - minY,
        width: maxX - minX
      };
    },
    getBBoxFromVertexes: function getBBoxFromVertexes(sPoint, tPoint) {
      var minX = Math.min(sPoint.x, tPoint.x),
          maxX = Math.max(sPoint.x, tPoint.x),
          minY = Math.min(sPoint.y, tPoint.y),
          maxY = Math.max(sPoint.y, tPoint.y);
      return {
        centerX: (minX + maxX) / 2,
        centerY: (minY + maxY) / 2,
        maxX: maxX,
        maxY: maxY,
        minX: minX,
        minY: minY,
        height: maxY - minY,
        width: maxX - minX
      };
    },
    vertexOfBBox: function vertexOfBBox(bbox) {
      return [{
        x: bbox.minX,
        y: bbox.minY
      }, {
        x: bbox.maxX,
        y: bbox.minY
      }, {
        x: bbox.maxX,
        y: bbox.maxY
      }, {
        x: bbox.minX,
        y: bbox.maxY
      }];
    },
    crossPointsByLineAndBBox: function crossPointsByLineAndBBox(bbox, centerPoint) {
      var crossPoints = [];
      if (!(centerPoint.x < bbox.minX || centerPoint.x > bbox.maxX)) crossPoints = crossPoints.concat([{
        x: centerPoint.x,
        y: bbox.minY
      }, {
        x: centerPoint.x,
        y: bbox.maxY
      }]);
      if (!(centerPoint.y < bbox.minY || centerPoint.y > bbox.maxY)) crossPoints = crossPoints.concat([{
        x: bbox.minX,
        y: centerPoint.y
      }, {
        x: bbox.maxX,
        y: centerPoint.y
      }]);
      return crossPoints;
    },
    getConnectablePoints: function getConnectablePoints(sBBox, tBBox, sPoint, tPoint) {
      var _this = this;

      var lineBBox = this.getBBoxFromVertexes(sPoint, tPoint);
      var outerBBox = this.combineBBoxes(sBBox, tBBox);
      var sLineBBox = this.combineBBoxes(sBBox, lineBBox);
      var tLineBBox = this.combineBBoxes(tBBox, lineBBox);
      var points = [];
      points = points.concat(this.vertexOfBBox(sLineBBox), this.vertexOfBBox(tLineBBox), this.vertexOfBBox(outerBBox));
      var centerPoint = {
        x: outerBBox.centerX,
        y: outerBBox.centerY
      };
      [outerBBox, sLineBBox, tLineBBox, lineBBox].forEach(function (bbox) {
        points = points.concat(_this.crossPointsByLineAndBBox(bbox, centerPoint));
      });
      points.push({
        x: sPoint.x,
        y: tPoint.y
      });
      points.push({
        x: tPoint.x,
        y: sPoint.y
      });
      return points;
    },
    filterConnectablePoints: function filterConnectablePoints(points, bbox) {
      return points.filter(function (point) {
        return point.x <= bbox.minX || point.x >= bbox.maxX || point.y <= bbox.minY || point.y >= bbox.maxY;
      });
    },
    AStar: function AStar(points, sPoint, tPoint, sBBox, tBBox) {
      var _this2 = this;

      var openList = [sPoint];
      var closeList = [];
      points = _.uniqBy(this.fillId(points), 'id');
      points.push(tPoint);
      var endPoint;

      var _loop = function _loop() {
        var minCostPoint = void 0;
        openList.forEach(function (p, i) {
          if (!p.parent) p.f = 0;
          if (!minCostPoint) minCostPoint = p;
          if (p.f < minCostPoint.f) minCostPoint = p;
        });

        if (minCostPoint.x === tPoint.x && minCostPoint.y === tPoint.y) {
          endPoint = minCostPoint;
          return "break";
        }

        openList.splice(openList.findIndex(function (o) {
          return o.x === minCostPoint.x && o.y === minCostPoint.y;
        }), 1);
        closeList.push(minCostPoint);
        var neighbor = points.filter(function (p) {
          return (p.x === minCostPoint.x || p.y === minCostPoint.y) && !(p.x === minCostPoint.x && p.y === minCostPoint.y) && !_this2.crossBBox([sBBox, tBBox], minCostPoint, p);
        });
        neighbor.forEach(function (p) {
          var inOpen = openList.find(function (o) {
            return o.x === p.x && o.y === p.y;
          });

          var currentG = _this2.getCost(p, minCostPoint);

          if (closeList.find(function (o) {
            return o.x === p.x && o.y === p.y;
          })) ; else if (inOpen) {
            if (p.g > currentG) {
              p.parent = minCostPoint;
              p.g = currentG;
              p.f = p.g + p.h;
            }
          } else {
            p.parent = minCostPoint;
            p.g = currentG;

            var h = _this2.getCost(p, tPoint);

            if (_this2.crossBBox([tBBox], p, tPoint)) {
              h += tBBox.width / 2 + tBBox.height / 2; //如果穿过bbox则增加该点的预估代价为bbox周长的一半
            }

            p.h = h;
            p.f = p.g + p.h;
            openList.push(p);
          }
        });
      };

      while (openList.length > 0) {
        var _ret = _loop();

        if (_ret === "break") break;
      }

      if (endPoint) {
        var result = [];
        result.push({
          x: endPoint.x,
          y: endPoint.y
        });

        while (endPoint.parent) {
          endPoint = endPoint.parent;
          result.push({
            x: endPoint.x,
            y: endPoint.y
          });
        }

        return result.reverse();
      }

      return [];
    },
    crossBBox: function crossBBox(bboxes, p1, p2) {
      for (var i = 0; i < bboxes.length; i++) {
        var bbox = bboxes[i];

        if (p1.x === p2.x && bbox.minX < p1.x && bbox.maxX > p1.x) {
          if (p1.y < bbox.maxY && p2.y >= bbox.maxY || p2.y < bbox.maxY && p1.y >= bbox.maxY) return true;
        } else if (p1.y === p2.y && bbox.minY < p1.y && bbox.maxY > p1.y) {
          if (p1.x < bbox.maxX && p2.x >= bbox.maxX || p2.x < bbox.maxX && p1.x >= bbox.maxX) return true;
        }
      }

      return false;
    },
    getCost: function getCost(p1, p2) {
      return Math.abs(p1.x - p2.x) + Math.abs(p1.y - p2.y);
    },
    getPointBBox: function getPointBBox(t) {
      return {
        centerX: t.x,
        centerY: t.y,
        minX: t.x,
        minY: t.y,
        maxX: t.x,
        maxY: t.y,
        height: 0,
        width: 0
      };
    },
    fillId: function fillId(points) {
      points.forEach(function (p) {
        p.id = p.x + '-' + p.y;
      });
      return points;
    },
    polylineFinding: function polylineFinding(sNode, tNode, sPort, tPort, offset) {
      var sourceBBox = sNode && sNode.getBBox() ? sNode.getBBox() : this.getPointBBox(sPort);
      var targetBBox = tNode && tNode.getBBox() ? tNode.getBBox() : this.getPointBBox(tPort);
      var sBBox = this.getExpandedBBox(sourceBBox, offset);
      var tBBox = this.getExpandedBBox(targetBBox, offset);
      var sPoint = this.getExpandedPort(sBBox, sPort);
      var tPoint = this.getExpandedPort(tBBox, tPort);
      var points = this.getConnectablePoints(sBBox, tBBox, sPoint, tPoint);
      points = this.filterConnectablePoints(points, sBBox);
      points = this.filterConnectablePoints(points, tBBox);
      var polylinePoints = this.AStar(points, sPoint, tPoint, sBBox, tBBox);
      return polylinePoints;
    }
  }, 'polyline');
}

function registerItem (G6) {
  registerAnchor(G6);
  registerNode(G6);
  registerEdge(G6);
}

function clickSelected (G6) {
  G6.registerBehavior('clickSelected', {
    getDefaultCfg: function getDefaultCfg() {
      return {
        multiple: false
      };
    },
    getEvents: function getEvents() {
      return {
        'node:click': 'onClick',
        'edge:click': 'onClick',
        'edge:mouseover': 'onEdgeMouseOver',
        'edge:mouseleave': 'onEdgeMouseLeave',
        'canvas:click': 'onCanvasClick',
        'node:mouseover': 'onNodeMouseOver'
      };
    },
    onClick: function onClick(e) {
      this._clearSelected();

      this.graph.setItemState(e.item, 'selected', true);
      var selectedItems = this.graph.get('selectedItems');
      if (!selectedItems) selectedItems = [];
      selectedItems = [e.item.get('id')];
      this.graph.set('selectedItems', selectedItems);
      this.graph.emit('afteritemselected', selectedItems);
    },
    onNodeMouseOver: function onNodeMouseOver(e) {
      if (this.graph.getCurrentMode() === 'edit') this.graph.setItemState(e.item, 'hover', true);else this.graph.setItemState(e.item, 'hover', false);
    },
    onEdgeMouseOver: function onEdgeMouseOver(e) {
      if (this.graph.getCurrentMode() === 'edit' && !e.item.hasState('selected')) this.graph.setItemState(e.item, 'hover', true);
    },
    onEdgeMouseLeave: function onEdgeMouseLeave(e) {
      if (this.graph.getCurrentMode() === 'edit' && !e.item.hasState('selected')) this.graph.setItemState(e.item, 'hover', false);
    },
    onCanvasClick: function onCanvasClick() {
      this._clearSelected();
    },
    _clearSelected: function _clearSelected() {
      var _this = this;

      var selected = this.graph.findAllByState('node', 'selected');
      selected.forEach(function (node) {
        _this.graph.setItemState(node, 'selected', false);
      });
      selected = this.graph.findAllByState('edge', 'selected');
      selected.forEach(function (edge) {
        _this.graph.setItemState(edge, 'selected', false);
      });
      this.graph.set('selectedItems', []);
      this.graph.emit('afteritemselected', []);
    }
  });
}

function deleteItem (G6) {
  G6.registerBehavior('deleteItem', {
    getEvents: function getEvents() {
      return {
        'keydown': 'onKeydown',
        'canvas:mouseleave': 'onCanvasLeave',
        'canvas:mouseenter': 'onCanvasFocus'
      };
    },
    onKeydown: function onKeydown(e) {
      var items = this.graph.get('selectedItems');
      var focus = this.graph.get('focusGraphWrapper');

      if (e.keyCode === 8 && items && items.length > 0 && focus) {
        if (this.graph.executeCommand) {
          this.graph.executeCommand('delete', {});
        } else {
          this.graph.remove(items[0]);
        }

        this.graph.set('selectedItems', []);
        this.graph.emit('afteritemselected', []);
      }
    },
    onCanvasLeave: function onCanvasLeave(e) {
      this.graph.set('focusGraphWrapper', false);
    },
    onCanvasFocus: function onCanvasFocus() {
      this.graph.set('focusGraphWrapper', true);
    }
  });
}

var each$3 = require('@antv/util/lib/each');

function dragNode (G6) {
  G6.registerBehavior('dragNode', {
    getDefaultCfg: function getDefaultCfg() {
      return {
        updateEdge: true,
        delegate: true,
        delegateStyle: {},
        align: true
      };
    },
    getEvents: function getEvents() {
      return {
        'node:dragstart': 'onDragStart',
        'node:drag': 'onDrag',
        'node:dragend': 'onDragEnd'
      };
    },
    onDragStart: function onDragStart(e) {
      if (!this.shouldBegin.call(this, e)) {
        return;
      }

      this.target = e.item;
      this.origin = {
        x: e.x,
        y: e.y
      };
    },
    onDrag: function onDrag(e) {
      if (!this.origin) {
        return;
      }

      if (!this.get('shouldUpdate').call(this, e)) {
        return;
      }

      this._update(this.target, e);
    },
    onDragEnd: function onDragEnd(e) {
      if (!this.shouldEnd.call(this, e)) {
        return;
      }

      if (!this.origin) {
        return;
      }

      var delegateShape = e.item.get('delegateShape');

      if (delegateShape) {
        delegateShape.remove();
        this.target.set('delegateShape', null);
      }

      this._update(this.target, e, true);

      this.point = null;
      this.origin = null;
      this.graph.emit('afternodedragend');
    },
    _update: function _update(item, e, force) {
      var origin = this.origin;
      var model = item.get('model');

      if (!this.point) {
        this.point = {
          x: model.x,
          y: model.y
        };
      }

      var x = e.x - origin.x + this.point.x;
      var y = e.y - origin.y + this.point.y;
      this.origin = {
        x: e.x,
        y: e.y
      };
      this.point = {
        x: x,
        y: y
      };

      if (this.delegate && !force) {
        this._updateDelegate(item, x, y);

        return;
      }

      if (this.graph.executeCommand) {
        this.graph.executeCommand('update', {
          itemId: item.get('id'),
          updateModel: {
            x: x,
            y: y
          }
        });
      } else {
        if (this.get('updateEdge')) {
          this.graph.updateItem(item, {
            x: x,
            y: y
          });
        } else {
          item.updatePosition({
            x: x,
            y: y
          });
          this.graph.paint();
        }
      }
    },
    _updateDelegate: function _updateDelegate(item, x, y) {
      var self = this;
      var shape = item.get('delegateShape');
      var bbox = item.get('keyShape').getBBox();

      if (!shape) {
        var parent = self.graph.get('group');
        var attrs = editorStyle.nodeDelegationStyle; // model上的x, y是相对于图形中心的，delegateShape是g实例，x,y是绝对坐标

        shape = parent.addShape('rect', {
          attrs: _objectSpread({
            width: bbox.width,
            height: bbox.height,
            x: x - bbox.width / 2,
            y: y - bbox.height / 2
          }, attrs)
        });
        shape.set('capture', false);
        item.set('delegateShape', shape);
      }

      shape.attr({
        x: x - bbox.width / 2,
        y: y - bbox.height / 2
      });
      this.graph.paint();
      this.graph.emit('afternodedrag', shape);
    }
  });
}

function dragEdge (G6) {
  G6.registerBehavior('dragEdge', {
    getDefaultCfg: function getDefaultCfg() {
      return {
        updateEdge: true,
        delegate: true,
        delegateStyle: {},
        dragEdge: false
      };
    },
    getEvents: function getEvents() {
      return {
        'anchor:dragstart': 'onDragStart',
        'anchor:drag': 'onDrag',
        'anchor:dragend': 'onDragEnd',
        'anchor:dragenter': 'onDragEnter',
        'anchor:dragleave': 'onDragLeave'
      };
    },
    onDragEnter: function onDragEnter(e) {
      if (!this.origin) {
        return;
      }

      if (!this.sameNode(e)) {
        e.item.setHotspotActived(true);
        this.origin.targetNode = e.target.getParent().getParent().get('item');
        this.origin.targetAnchor = e.item.get('index');
      }
    },
    onDragLeave: function onDragLeave(e) {
      if (!this.origin) {
        return;
      }

      if (!this.sameNode(e)) {
        e.item.setHotspotActived(false);
        this.origin.targetNode = null;
        this.origin.targetAnchor = null;
      }
    },
    onDragStart: function onDragStart(e) {
      var node = e.target.getParent().getParent().get('item');
      var anchorIndex = e.item.get('index');
      var point = node.getAnchorPoints()[anchorIndex];
      this.target = e.item;
      this.origin = {
        x: point.x,
        y: point.y,
        sourceNode: node,
        sourceAnchor: anchorIndex
      };
      this.dragEdgeBeforeShowAnchor(e);
      this.graph.set('onDragEdge', true);
    },
    onDrag: function onDrag(e) {
      if (!this.origin) {
        return;
      }

      this._updateEdge(this.target, e);
    },
    onDragEnd: function onDragEnd(e) {
      if (!this.origin) {
        return;
      }

      var delegateShape = e.item.get('edgeDelegate');

      if (delegateShape) {
        delegateShape.remove();
        this.target.set('edgeDelegate', null);
      }

      this._updateEdge(this.target, e, true);

      this.graph.setItemState(this.origin.sourceNode, 'show-anchor', false);
      this.target = null;
      this.origin = null;
      this.graph.set('onDragEdge', false);
    },
    sameNode: function sameNode(e) {
      return e.target.type === 'marker' && e.target.getParent() && e.target.getParent().getParent().get('item').get('id') === this.origin.sourceNode.get('id');
    },
    dragEdgeBeforeShowAnchor: function dragEdgeBeforeShowAnchor(e) {
      this.graph.getNodes().forEach(function (node) {
        if (node.getModel().clazz === 'startEvent' || node.getModel().clazz === 'timerStartEvent' || node.getModel().clazz === 'messageStartEvent') return;
        var group = node.getContainer();
        group.showAnchor(group);
        group.anchorShapes.forEach(function (a) {
          return a.get('item').showHotpot();
        });
      });
    },
    _updateEdge: function _updateEdge(item, e, force) {
      var x = e.x;
      var y = e.y;

      if (this.delegate && !force) {
        this._updateEdgeDelegate(item, x, y);

        return;
      }

      this._addEdge(e);

      this._clearAllAnchor();

      this.graph.paint();
    },
    _updateEdgeDelegate: function _updateEdgeDelegate(item, x, y) {
      var self = this;
      var edgeShape = item.get('edgeDelegate');

      if (!edgeShape) {
        var parent = self.graph.get('group');
        edgeShape = parent.addShape('line', {
          attrs: _objectSpread({
            x1: this.origin.x,
            y1: this.origin.y,
            x2: x,
            y2: y
          }, editorStyle.edgeDelegationStyle)
        });
        edgeShape.set('capture', false);
        item.set('edgeDelegate', edgeShape);
      }

      edgeShape.attr({
        x2: x,
        y2: y
      });
      this.graph.paint();
    },
    _clearAllAnchor: function _clearAllAnchor() {
      this.graph.getNodes().forEach(function (node) {
        var group = node.getContainer();
        group.clearAnchor(group);
      });
    },
    _addEdge: function _addEdge() {
      if (this.origin.targetNode) {
        var addModel = {
          clazz: 'flow',
          source: this.origin.sourceNode.get('id'),
          target: this.origin.targetNode.get('id'),
          sourceAnchor: this.origin.sourceAnchor,
          targetAnchor: this.origin.targetAnchor
        };

        if (this.graph.executeCommand) {
          this.graph.executeCommand('add', {
            type: 'edge',
            addModel: addModel
          });
        } else {
          this.graph.add('edge', addModel);
        }
      }
    }
  });
}

function dragPanelItemAddNode (G6) {
  G6.registerBehavior('dragPanelItemAddNode', {
    getDefaultCfg: function getDefaultCfg() {
      return {};
    },
    getEvents: function getEvents() {
      return {
        'canvas:mousemove': 'onMouseMove',
        'canvas:mouseup': 'onMouseUp',
        'canvas:mouseleave': 'onMouseLeave'
      };
    },
    onMouseMove: function onMouseMove(e) {
      if (this.graph.get('onDragAddNode')) {
        var delegateShape = this.graph.get('addDelegateShape');
        var addModel = this.graph.get('addModel');
        var width = parseInt(addModel.size.split('*')[0]);
        var height = parseInt(addModel.size.split('*')[1]);
        var point = this.graph.getPointByClient(e.x, e.y);
        var x = point.x;
        var y = point.y;

        if (!delegateShape) {
          var parent = this.graph.get('group');
          delegateShape = parent.addShape('rect', {
            attrs: _objectSpread({
              width: width,
              height: height,
              x: x - width / 2,
              y: y - height / 2
            }, editorStyle.nodeDelegationStyle)
          });
          delegateShape.set('capture', false);
          this.graph.set('addDelegateShape', delegateShape);
        }

        delegateShape.attr({
          x: x - width / 2,
          y: y - height / 2
        });
        this.graph.paint();
        this.graph.emit('afternodedrag', delegateShape);
      }
    },
    onMouseUp: function onMouseUp(e) {
      if (this.graph.get('onDragAddNode')) {
        var p = this.graph.getPointByClient(e.clientX, e.clientY);
        if (p.x > 0 && p.y > 0) this._addNode(p);
      }
    },
    onMouseLeave: function onMouseLeave(e) {
      if (this.graph.get('onDragAddNode')) {
        this._clearDelegate();

        this.graph.emit('afternodedragend');
      }
    },
    _clearDelegate: function _clearDelegate() {
      if (this.graph.get('onDragAddNode')) {
        var delegateShape = this.graph.get('addDelegateShape');

        if (delegateShape) {
          delegateShape.remove();
          this.graph.set('addDelegateShape', null);
          this.graph.paint();
        }
      }
    },
    _addNode: function _addNode(p) {
      if (this.graph.get('onDragAddNode')) {
        var addModel = this.graph.get('addModel');
        var _addModel$clazz = addModel.clazz,
            clazz = _addModel$clazz === void 0 ? 'userTask' : _addModel$clazz;
        addModel.shape = getShapeName(clazz);
        var timestamp = new Date().getTime();
        var id = clazz + timestamp;
        var x = p.x;
        var y = p.y;

        if (this.graph.executeCommand) {
          this.graph.executeCommand('add', {
            type: 'node',
            addModel: _objectSpread({}, addModel, {
              x: x,
              y: y,
              id: id
            })
          });
        } else {
          this.graph.add('node', _objectSpread({}, addModel, {
            x: x,
            y: y,
            id: id
          }));
        }
      }
    }
  });
}

function hoverAnchorActived (G6) {
  G6.registerBehavior('hoverAnchorActived', {
    getEvents: function getEvents() {
      return {
        'anchor:mouseenter': 'onAnchorEnter',
        'anchor:mousemove': 'onAnchorEnter',
        'anchor:mouseleave': 'onAnchorLeave'
      };
    },
    onAnchorEnter: function onAnchorEnter(e) {
      if (!this.graph.get('onDragEdge')) this.graph.setItemState(e.item, 'active-anchor', true);
    },
    onAnchorLeave: function onAnchorLeave(e) {
      if (!this.graph.get('onDragEdge')) {
        var node = e.item.getContainer().getParent();

        if (node) {
          this.graph.setItemState(e.item, 'active-anchor', false);
        }
      }
    }
  });
}

function hoverNodeActived (G6) {
  G6.registerBehavior('hoverNodeActived', {
    getEvents: function getEvents() {
      return {
        'node:mouseenter': 'onNodeEnter',
        'node:mouseleave': 'onNodeLeave',
        'anchor:mouseleave': 'onAnchorLeave'
      };
    },
    onAnchorLeave: function onAnchorLeave(e) {
      var node = e.item.getContainer().getParent();

      if (node && !this.graph.get('onDragEdge')) {
        this.graph.setItemState(node.get('item'), 'show-anchor', false);
      }
    },
    onNodeEnter: function onNodeEnter(e) {
      var clazz = e.item.getModel().clazz;
      if (clazz !== 'endEvent' && !this.graph.get('onDragEdge')) this.graph.setItemState(e.item, 'show-anchor', true);
    },
    onNodeLeave: function onNodeLeave(e) {
      if (e.target.type !== 'marker' && !this.graph.get('onDragEdge')) {
        this.graph.setItemState(e.item, 'show-anchor', false);
      }
    }
  });
}

var each$4 = require('@antv/util/lib/each');

var vec2 = require('@antv/util/lib/matrix/vec2');

var mix = require('@antv/util/lib/mix');

function itemAlign (G6) {
  G6.registerBehavior('itemAlign', {
    getDefaultCfg: function getDefaultCfg() {
      return {
        alignLineStyle: {
          stroke: '#FA8C16',
          lineWidth: 1
        },
        tolerance: 5,
        _alignLines: []
      };
    },
    getEvents: function getEvents() {
      return {
        'afternodedrag': 'onDrag',
        'afternodedragend': 'onDragEnd'
      };
    },
    onDrag: function onDrag(shape) {
      this._clearAlignLine();

      this._itemAlign(shape);
    },
    onDragEnd: function onDragEnd() {
      this._clearAlignLine();
    },
    _itemAlign: function _itemAlign(item) {
      var _this = this;

      var bbox = item.getBBox();
      var ct = {
        x: bbox.x + bbox.width / 2,
        y: bbox.y
      };
      var cc = {
        x: bbox.x + bbox.width / 2,
        y: bbox.y + bbox.height / 2
      };
      var cb = {
        x: bbox.x + bbox.width / 2,
        y: bbox.y + bbox.height
      };
      var lc = {
        x: bbox.x,
        y: bbox.y + bbox.height / 2
      };
      var rc = {
        x: bbox.x + bbox.width,
        y: bbox.y + bbox.height / 2
      };
      var nodes = this.graph.getNodes();
      each$4(nodes, function (node) {
        var horizontalLines = [];
        var verticalLines = [];
        var p = null;
        var bbox1 = node.getBBox();
        each$4(_this.getHorizontalLines(bbox1), function (line) {
          horizontalLines.push(_this.getDistance(line, ct));
          horizontalLines.push(_this.getDistance(line, cc));
          horizontalLines.push(_this.getDistance(line, cb));
        });
        each$4(_this.getVerticalLines(bbox1), function (line) {
          verticalLines.push(_this.getDistance(line, lc));
          verticalLines.push(_this.getDistance(line, cc));
          verticalLines.push(_this.getDistance(line, rc));
        });
        horizontalLines.sort(function (a, b) {
          return a.dis - b.dis;
        });
        verticalLines.sort(function (a, b) {
          return a.dis - b.dis;
        });

        if (horizontalLines.length > 0 && horizontalLines[0].dis < _this.tolerance) {
          item.attr({
            y: horizontalLines[0].line[1] - horizontalLines[0].point.y + bbox.y
          });
          p = {
            horizontals: [horizontalLines[0]]
          };

          for (var i = 1; i < 3; i++) {
            horizontalLines[0].dis === horizontalLines[i].dis && p.horizontals.push(horizontalLines[i]);
          }
        }

        if (verticalLines.length > 0 && verticalLines[0].dis < _this.tolerance) {
          item.attr({
            x: verticalLines[0].line[0] - verticalLines[0].point.x + bbox.x
          });
          p ? p.verticals = [verticalLines[0]] : p = {
            verticals: [verticalLines[0]]
          };

          for (var _i = 1; _i < 3; _i++) {
            verticalLines[0].dis === verticalLines[_i].dis && p.verticals.push(verticalLines[_i]);
          }
        }

        if (p) {
          p.bbox = bbox;

          _this._addAlignLine(p);
        }
      });
    },
    _addAlignLine: function _addAlignLine(p) {
      var group = this.graph.get('group');
      var bbox = p.bbox;
      var lineStyle = this.alignLineStyle;
      var lineArr = this._alignLines;

      if (p.horizontals) {
        each$4(p.horizontals, function (lineObj) {
          var line = lineObj.line;
          var point = lineObj.point;
          var lineHalf = (line[0] + line[2]) / 2;
          var x1, x2;

          if (point.x < lineHalf) {
            x1 = point.x - bbox.width / 2;
            x2 = Math.max(line[0], line[2]);
          } else {
            x1 = point.x + bbox.width / 2;
            x2 = Math.min(line[0], line[2]);
          }

          var shape = group.addShape('line', {
            attrs: mix({
              x1: x1,
              y1: line[1],
              x2: x2,
              y2: line[1]
            }, lineStyle),
            capture: false
          });
          lineArr.push(shape);
        });
      }

      if (p.verticals) {
        each$4(p.verticals, function (lineObj) {
          var line = lineObj.line;
          var point = lineObj.point;
          var lineHalf = (line[1] + line[3]) / 2;
          var y1, y2;

          if (point.y < lineHalf) {
            y1 = point.y - bbox.height / 2;
            y2 = Math.max(line[1], line[3]);
          } else {
            y1 = point.y + bbox.height / 2;
            y2 = Math.min(line[1], line[3]);
          }

          var shape = group.addShape('line', {
            attrs: mix({
              x1: line[0],
              y1: y1,
              x2: line[0],
              y2: y2
            }, lineStyle),
            capture: false
          });
          lineArr.push(shape);
        });
      }
    },
    getHorizontalLines: function getHorizontalLines(bbox) {
      return [[bbox.minX, bbox.minY, bbox.maxX, bbox.minY], // tltr
      [bbox.minX, bbox.centerY, bbox.maxX, bbox.centerY], // lcrc
      [bbox.minX, bbox.maxY, bbox.maxX, bbox.maxY]];
    },
    getVerticalLines: function getVerticalLines(bbox) {
      return [[bbox.minX, bbox.minY, bbox.minX, bbox.maxY], // tlbl
      [bbox.centerX, bbox.minY, bbox.centerX, bbox.maxY], // tcbc
      [bbox.maxX, bbox.minY, bbox.maxX, bbox.maxY]];
    },
    getDistance: function getDistance(line, point) {
      return {
        line: line,
        point: point,
        dis: this.pointLineDistance(line[0], line[1], line[2], line[3], point.x, point.y)
      };
    },
    pointLineDistance: function pointLineDistance(lineX1, lineY1, lineX2, lineY2, pointX, pointY) {
      var lineLength = [lineX2 - lineX1, lineY2 - lineY1];
      if (vec2.exactEquals(lineLength, [0, 0])) return NaN;
      var s = [-lineLength[1], lineLength[0]];
      vec2.normalize(s, s);
      return Math.abs(vec2.dot([pointX - lineX1, pointY - lineY1], s));
    },
    _clearAlignLine: function _clearAlignLine() {
      each$4(this._alignLines, function (line) {
        line.remove();
      });
      this._alignLines = [];
    }
  });
}

function registerBehavior (G6) {
  clickSelected(G6);
  deleteItem(G6);
  dragNode(G6);
  dragEdge(G6);
  dragPanelItemAddNode(G6);
  hoverAnchorActived(G6);
  hoverNodeActived(G6);
  itemAlign(G6);
}

library.add(faShare, faCopy, faPaste, faTrashAlt, faSearchPlus, faSearchMinus, faCompress, faExpand, faLayerGroup, faLayerUp, faLayerDown, faUndo, faRedo);
registerItem(G6);
registerBehavior(G6);
var Panel = Collapse.Panel;
var LangContext = React.createContext();

var DetailPanel = function DetailPanel(_ref) {
  var model = _ref.model,
      users = _ref.users,
      groups = _ref.groups,
      _onChange = _ref.onChange,
      _ref$readOnly = _ref.readOnly,
      readOnly = _ref$readOnly === void 0 ? false : _ref$readOnly;
  return React.createElement(LangContext.Consumer, null, function (i18n) {
    var title;
    if (model.clazz === 'userTask') title = i18n['userTask'];else if (model.clazz === 'javaTask') title = i18n['javaTask'];else if (model.clazz === 'scriptTask') title = i18n['scriptTask'];else if (model.clazz === 'mailTask') title = i18n['mailTask'];else if (model.clazz === 'receiveTask') title = i18n['receiveTask'];else if (model.clazz === 'gateway') title = i18n['exclusiveGateway'];else if (model.clazz === 'flow') title = i18n['sequenceFlow'];else if (model.clazz === 'start') title = i18n['startEvent'];else if (model.clazz === 'end') title = i18n['endEvent'];else if (model.clazz === 'timerStart' || model.clazz === 'timerCatch') title = i18n['timerEvent'];else if (model.clazz === 'messageStart' || model.clazz === 'messageCatch') title = i18n['messageEvent'];else if (model.clazz === 'signalStart' || model.clazz === 'signalCatch') title = i18n['signalEvent'];
    return model.clazz ? React.createElement("div", {
      "data-clazz": model.clazz
    }, React.createElement("div", {
      className: styles.panelTitle
    }, title), React.createElement("div", {
      className: styles.panelBody
    }, React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", null, i18n['label'], "\uFF1A"), React.createElement(Input, {
      style: {
        width: '100%',
        fontSize: 12
      },
      value: model.label,
      onChange: function onChange(e) {
        return _onChange('label', e.target.value);
      },
      disabled: readOnly
    })), React.createElement("div", {
      className: styles.panelRow
    }, React.createElement(Checkbox, {
      onChange: function onChange(e) {
        return _onChange('hideIcon', e.target.checked);
      },
      disabled: readOnly,
      checked: !!model.hideIcon
    }, i18n['hideIcon'])), model.clazz === 'userTask' && React.createElement(Fragment, null, React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", null, i18n['userTask.assignType'], "\uFF1A"), React.createElement(Select, {
      style: {
        width: '100%',
        fontSize: 12
      },
      placeholder: i18n['userTask.assignType.placeholder'],
      defaultValue: "person",
      value: model.assignType,
      onChange: function onChange(e) {
        _onChange('assignValue', []);

        _onChange('assignType', e);
      },
      disabled: readOnly
    }, React.createElement(Select.Option, {
      key: "person"
    }, i18n['userTask.assignType.person']), React.createElement(Select.Option, {
      key: "persongroup"
    }, i18n['userTask.assignType.persongroup']), React.createElement(Select.Option, {
      key: "custom"
    }, i18n['userTask.assignType.custom']))), model.assignType === 'person' && React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", null, i18n['userTask.assignType.person.title'], "\uFF1A"), React.createElement(Select, {
      mode: "multiple",
      showSearch: true,
      style: {
        width: '100%',
        fontSize: 12
      },
      placeholder: i18n['userTask.assignType.person.placeholder'],
      optionFilterProp: "children",
      defaultValue: model.assignValue,
      onChange: function onChange(e) {
        return _onChange('assignValue', e);
      },
      filterOption: function filterOption(input, option) {
        return option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0;
      },
      disabled: readOnly
    }, users && users.map(function (user) {
      return React.createElement(Select.Option, {
        key: user.id
      }, user.name);
    }))), model.assignType === 'persongroup' && React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", null, i18n['userTask.assignType.persongroup.title'], "\uFF1A"), React.createElement(Select, {
      mode: "multiple",
      showSearch: true,
      style: {
        width: '100%',
        fontSize: 12
      },
      placeholder: i18n['userTask.assignType.persongroup.placeholder'],
      optionFilterProp: "children",
      defaultValue: model.assignValue,
      onChange: function onChange(e) {
        return _onChange('assignValue', e);
      },
      filterOption: function filterOption(input, option) {
        return option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0;
      },
      disabled: readOnly
    }, groups && groups.map(function (group) {
      return React.createElement(Select.Option, {
        key: group.id
      }, group.name);
    }))), model.assignType === 'custom' && React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", null, i18n['userTask.assignType.custom.title'], "\uFF1A"), React.createElement(Input, {
      style: {
        width: '100%',
        fontSize: 12
      },
      value: model.javaClass,
      onChange: function onChange(e) {
        _onChange('javaClass', e.target.value);
      },
      disabled: readOnly
    })), React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['userTask.dueDate'], "\uFF1A"), React.createElement(DatePicker, {
      defaultValue: model.dueDate ? moment(model.dueDate) : null,
      disabled: readOnly,
      placeholder: i18n['userTask.dueDate.placeholder'],
      showTime: true,
      style: {
        width: '100%',
        minWidth: null
      },
      onChange: function onChange(value, dateString) {
        return _onChange('dueDate', value);
      }
    })), React.createElement("div", {
      className: styles.panelRow
    }, React.createElement(Checkbox, {
      onChange: function onChange(e) {
        return _onChange('isSequential', e.target.checked);
      },
      disabled: readOnly,
      checked: !!model.isSequential
    }, i18n['userTask.counterSign']))), model.clazz === 'scriptTask' && React.createElement(Fragment, null, React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['scriptTask.script'], "\uFF1A"), React.createElement(Input.TextArea, {
      style: {
        width: '100%',
        fontSize: 12
      },
      rows: 4,
      value: model.script,
      onChange: function onChange(e) {
        _onChange('script', e.target.value);
      },
      disabled: readOnly
    }))), model.clazz === 'javaTask' && React.createElement(Fragment, null, React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['javaTask.javaClass'], "\uFF1A"), React.createElement(Input, {
      style: {
        width: '100%',
        fontSize: 12
      },
      value: model.javaClass,
      onChange: function onChange(e) {
        _onChange('javaClass', e.target.value);
      },
      disabled: readOnly
    }))), model.clazz === 'receiveTask' && React.createElement(Fragment, null, React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['receiveTask.waitState'], "\uFF1A"), React.createElement(Input, {
      style: {
        width: '100%',
        fontSize: 12
      },
      value: model.waitState,
      onChange: function onChange(e) {
        _onChange('waitState', e.target.value);
      },
      disabled: readOnly
    })), React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['receiveTask.stateValue'], "\uFF1A"), React.createElement(Input, {
      style: {
        width: '100%',
        fontSize: 12
      },
      value: model.stateValue,
      onChange: function onChange(e) {
        _onChange('stateValue', e.target.value);
      },
      disabled: readOnly
    }))), model.clazz === 'mailTask' && React.createElement(Fragment, null, React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['mailTask.to'], "\uFF1A"), React.createElement(Input, {
      style: {
        width: '100%',
        fontSize: 12
      },
      value: model.to,
      onChange: function onChange(e) {
        _onChange('to', e.target.value);
      },
      disabled: readOnly
    })), React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['mailTask.subject'], "\uFF1A"), React.createElement(Input, {
      style: {
        width: '100%',
        fontSize: 12
      },
      value: model.subject,
      onChange: function onChange(e) {
        _onChange('subject', e.target.value);
      },
      disabled: readOnly
    })), React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['mailTask.content'], "\uFF1A"), React.createElement(Input.TextArea, {
      style: {
        width: '100%',
        fontSize: 12
      },
      rows: 4,
      value: model.content,
      onChange: function onChange(e) {
        _onChange('content', e.target.value);
      },
      disabled: readOnly
    }))), (model.clazz === 'timerStart' || model.clazz === 'timerCatch') && React.createElement(Fragment, null, React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['timerEvent.cycle'], "\uFF1A"), React.createElement(TimePicker, {
      defaultValue: model.cycle,
      placeholder: i18n['timerEvent.cycle.placeholder'],
      format: "HH:mm",
      disabled: readOnly,
      onChange: function onChange(time) {
        return _onChange('cycle', time);
      }
    })), React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['timerEvent.duration'], "\uFF1A"), React.createElement(TimePicker, {
      defaultValue: model.duration,
      placeholder: i18n['timerEvent.cycle.placeholder'],
      format: "HH:mm",
      disabled: readOnly,
      onChange: function onChange(time) {
        return _onChange('duration', time);
      }
    }))), (model.clazz === 'signalStart' || model.clazz === 'signalCatch') && React.createElement(Fragment, null, React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['signalEvent.signal'], "\uFF1A"), React.createElement(Input, {
      style: {
        width: '100%',
        fontSize: 12
      },
      value: model.signal,
      onChange: function onChange(e) {
        _onChange('signal', e.target.value);
      },
      disabled: readOnly
    }))), (model.clazz === 'messageStart' || model.clazz === 'messageCatch') && React.createElement(Fragment, null, React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", {
      style: {
        display: 'inline'
      }
    }, i18n['messageEvent.message'], "\uFF1A"), React.createElement(Input, {
      style: {
        width: '100%',
        fontSize: 12
      },
      value: model.message,
      onChange: function onChange(e) {
        _onChange('message', e.target.value);
      },
      disabled: readOnly
    }))), model.clazz === 'flow' && React.createElement(Fragment, null, React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", null, i18n['sequenceFlow.expression'], "\uFF1A"), React.createElement(Input.TextArea, {
      style: {
        width: '100%',
        fontSize: 12
      },
      rows: 4,
      value: model.conditionExpression,
      onChange: function onChange(e) {
        _onChange('conditionExpression', e.target.value);
      },
      disabled: readOnly
    })), React.createElement("div", {
      className: styles.panelRow
    }, React.createElement("div", null, i18n['sequenceFlow.seq'], "\uFF1A"), React.createElement(Input, {
      style: {
        width: '100%',
        fontSize: 12
      },
      value: model.seq,
      onChange: function onChange(e) {
        _onChange('seq', e.target.value);
      },
      disabled: readOnly
    })), React.createElement("div", {
      className: styles.panelRow
    }, React.createElement(Checkbox, {
      onChange: function onChange(e) {
        return _onChange('reverse', e.target.checked);
      },
      disabled: readOnly,
      checked: !!model.reverse
    }, i18n['sequenceFlow.reverse']))))) : React.createElement(Fragment, null);
  });
};

var Designer =
/*#__PURE__*/
function (_Component) {
  _inherits(Designer, _Component);

  function Designer(props) {
    var _this;

    _classCallCheck(this, Designer);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Designer).call(this, props));
    _this.pageRef = React.createRef();
    _this.toolbarRef = React.createRef();
    _this.itemPanelRef = React.createRef();
    _this.detailPanelRef = React.createRef();

    _this.resizeFunc = function () {};

    _this.state = {
      selectedModel: {}
    };
    return _this;
  }

  _createClass(Designer, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (prevProps.data !== this.props.data) {
        if (this.graph) {
          this.graph.changeData(this.initShape(this.props.data));
          this.graph.setMode(this.props.mode);
          this.graph.emit('canvas:click');

          if (this.cmdPlugin) {
            this.cmdPlugin.initPlugin(this.graph);
          }

          if (this.props.isView) {
            this.graph.fitView(5);
          }
        }
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
          isView = _this$props.isView,
          mode = _this$props.mode;
      var height = this.props.height - 1;
      var width = this.pageRef.current.offsetWidth;
      var plugins = [];

      if (!isView) {
        this.cmdPlugin = new Command();
        var toolbar = new Toolbar({
          container: this.toolbarRef.current
        });
        var addItemPanel = new AddItemPanel({
          container: this.itemPanelRef.current
        });
        var canvasPanel = new CanvasPanel({
          container: this.pageRef.current
        });
        plugins = [this.cmdPlugin, toolbar, addItemPanel, canvasPanel];
      }

      this.graph = new G6.Graph({
        plugins: plugins,
        container: this.pageRef.current,
        height: height,
        width: width,
        modes: {
          default: ['drag-canvas', 'clickSelected'],
          view: [],
          edit: ['drag-canvas', 'hoverNodeActived', 'hoverAnchorActived', 'dragNode', 'dragEdge', 'dragPanelItemAddNode', 'clickSelected', 'deleteItem', 'itemAlign']
        },
        defaultEdge: {
          shape: 'flow-polyline-round'
        }
      });

      if (isView) {
        this.graph.setMode('view');
      } else {
        this.graph.setMode(mode);
      }

      this.graph.data(this.props.data ? this.initShape(this.props.data) : {
        nodes: [],
        edges: []
      });
      this.graph.render();

      if (isView && this.props.data && this.props.data.nodes) {
        this.graph.fitView(5);
      }

      this.initEvents();
    }
  }, {
    key: "initShape",
    value: function initShape(data) {
      if (data && data.nodes) {
        return {
          nodes: data.nodes.map(function (node) {
            return _objectSpread({
              shape: getShapeName(node.clazz)
            }, node);
          }),
          edges: data.edges
        };
      }

      return data;
    }
  }, {
    key: "initEvents",
    value: function initEvents() {
      var _this2 = this;

      this.graph.on('afteritemselected', function (items) {
        if (items && items.length > 0) {
          var item = _this2.graph.findById(items[0]);

          _this2.setState({
            selectedModel: _objectSpread({}, item.getModel())
          });
        } else {
          _this2.setState({
            selectedModel: {}
          });
        }
      });
      var page = this.pageRef.current;
      var graph = this.graph;
      var height = this.props.height - 1;

      this.resizeFunc = function () {
        graph.changeSize(page.offsetWidth, height);
      };

      window.addEventListener("resize", this.resizeFunc);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("resize", this.resizeFunc);
      this.graph.getNodes().forEach(function (node) {
        node.getKeyShape().stopAnimate();
      });
    }
  }, {
    key: "onItemCfgChange",
    value: function onItemCfgChange(key, value) {
      var items = this.graph.get('selectedItems');

      if (items && items.length > 0) {
        var item = this.graph.findById(items[0]);

        if (this.graph.executeCommand) {
          this.graph.executeCommand('update', {
            itemId: items[0],
            updateModel: _defineProperty({}, key, value)
          });
        } else {
          this.graph.updateItem(item, _defineProperty({}, key, value));
        }

        this.setState({
          selectedModel: _objectSpread({}, item.getModel())
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var height = this.props.height;
      var _this$props2 = this.props,
          isView = _this$props2.isView,
          mode = _this$props2.mode,
          users = _this$props2.users,
          groups = _this$props2.groups,
          lang = _this$props2.lang;
      var i18n = locale[lang.toLowerCase()];
      var readOnly = mode !== "edit";
      return React.createElement(LangContext.Provider, {
        value: i18n
      }, React.createElement("div", {
        className: styles.root
      }, !isView && React.createElement("div", {
        className: styles.toolbar,
        ref: this.toolbarRef
      }, React.createElement("span", {
        className: styles.command,
        "data-command": "undo"
      }, React.createElement(FontAwesomeIcon, {
        icon: "undo",
        color: "#666"
      })), React.createElement("span", {
        className: styles.command,
        "data-command": "redo"
      }, React.createElement(FontAwesomeIcon, {
        icon: "redo",
        color: "#666"
      })), React.createElement("span", {
        className: styles.separator
      }), React.createElement("span", {
        className: styles.command,
        "data-command": "copy"
      }, React.createElement(FontAwesomeIcon, {
        icon: "copy",
        color: "#666"
      })), React.createElement("span", {
        className: styles.command,
        "data-command": "paste"
      }, React.createElement(FontAwesomeIcon, {
        icon: "paste",
        color: "#666"
      })), React.createElement("span", {
        className: styles.command,
        "data-command": "delete"
      }, React.createElement(FontAwesomeIcon, {
        icon: "trash-alt",
        color: "#666"
      })), React.createElement("span", {
        className: styles.separator
      }), React.createElement("span", {
        className: styles.command,
        "data-command": "zoomIn"
      }, React.createElement(FontAwesomeIcon, {
        icon: "search-plus",
        color: "#666"
      })), React.createElement("span", {
        className: styles.command,
        "data-command": "zoomOut"
      }, React.createElement(FontAwesomeIcon, {
        icon: "search-minus",
        color: "#666"
      })), React.createElement("span", {
        className: styles.command,
        "data-command": "resetZoom"
      }, React.createElement(FontAwesomeIcon, {
        icon: "compress",
        color: "#666"
      })), React.createElement("span", {
        className: styles.command,
        onClick: function onClick() {
          return _this3.graph.fitView(5);
        }
      }, React.createElement(FontAwesomeIcon, {
        icon: "expand",
        color: "#666"
      })), React.createElement("span", {
        className: styles.separator
      }), React.createElement("span", {
        className: styles.command,
        "data-command": "toFront"
      }, React.createElement(FontAwesomeIcon, {
        icon: "layer-up",
        color: "#666"
      })), React.createElement("span", {
        className: styles.command,
        "data-command": "toBack"
      }, React.createElement(FontAwesomeIcon, {
        icon: "layer-down",
        color: "#666"
      }))), React.createElement("div", null, !isView && React.createElement("div", {
        ref: this.itemPanelRef,
        className: styles.itemPanel,
        style: {
          height: height
        }
      }, React.createElement(Collapse, {
        bordered: false,
        defaultActiveKey: ['1']
      }, React.createElement(Panel, {
        header: i18n['start'],
        key: "1",
        forceRender: true
      }, React.createElement("img", {
        "data-item": "{clazz:'start',size:'30*30',label:''}",
        src: require('../assets/start.svg'),
        style: {
          width: 42,
          height: 42
        }
      }), React.createElement("div", null, i18n['startEvent']), React.createElement("img", {
        "data-item": "{clazz:'timerStart',size:'30*30',label:''}",
        src: require('../assets/timer-start.svg'),
        style: {
          width: 42,
          height: 42
        }
      }), React.createElement("div", null, i18n['timerEvent']), React.createElement("img", {
        "data-item": "{clazz:'messageStart',size:'30*30',label:''}",
        src: require('../assets/message-start.svg'),
        style: {
          width: 42,
          height: 42
        }
      }), React.createElement("div", null, i18n['messageEvent']), React.createElement("img", {
        "data-item": "{clazz:'signalStart',size:'30*30',label:''}",
        src: require('../assets/signal-start.svg'),
        style: {
          width: 42,
          height: 42
        }
      }), React.createElement("div", null, i18n['signalEvent'])), React.createElement(Panel, {
        header: i18n['task'],
        key: "2",
        forceRender: true
      }, React.createElement("img", {
        "data-item": "{clazz:'userTask',size:'80*44',label:'" + i18n['userTask'] + "'}",
        src: require('../assets/user-task.svg'),
        style: {
          width: 80,
          height: 44
        }
      }), React.createElement("div", null, i18n['userTask']), React.createElement("img", {
        "data-item": "{clazz:'scriptTask',size:'80*44',label:'" + i18n['scriptTask'] + "'}",
        src: require('../assets/script-task.svg'),
        style: {
          width: 80,
          height: 44
        }
      }), React.createElement("div", null, i18n['scriptTask']), React.createElement("img", {
        "data-item": "{clazz:'javaTask',size:'80*44',label:'" + i18n['javaTask'] + "'}",
        src: require('../assets/java-task.svg'),
        style: {
          width: 80,
          height: 44
        }
      }), React.createElement("div", null, i18n['javaTask']), React.createElement("img", {
        "data-item": "{clazz:'mailTask',size:'80*44',label:'" + i18n['mailTask'] + "'}",
        src: require('../assets/mail-task.svg'),
        style: {
          width: 80,
          height: 44
        }
      }), React.createElement("div", null, i18n['mailTask']), React.createElement("img", {
        "data-item": "{clazz:'receiveTask',size:'80*44',label:'" + i18n['receiveTask'] + "'}",
        src: require('../assets/receive-task.svg'),
        style: {
          width: 80,
          height: 44
        }
      }), React.createElement("div", null, i18n['receiveTask'])), React.createElement(Panel, {
        header: i18n['gateway'],
        key: "3",
        forceRender: true
      }, React.createElement("img", {
        "data-item": "{clazz:'gateway',size:'40*40',label:''}",
        src: require('../assets/gateway.svg'),
        style: {
          width: 48,
          height: 48
        }
      }), React.createElement("div", null, i18n['exclusiveGateway'])), React.createElement(Panel, {
        header: i18n['catch'],
        key: "4",
        forceRender: true
      }, React.createElement("img", {
        "data-item": "{clazz:'timerCatch',size:'50*30',label:''}",
        src: require('../assets/timer-catch.svg'),
        style: {
          width: 58,
          height: 38
        }
      }), React.createElement("div", null, i18n['timerEvent']), React.createElement("img", {
        "data-item": "{clazz:'messageCatch',size:'50*30',label:''}",
        src: require('../assets/message-catch.svg'),
        style: {
          width: 58,
          height: 38
        }
      }), React.createElement("div", null, i18n['messageEvent']), React.createElement("img", {
        "data-item": "{clazz:'signalCatch',size:'50*30',label:''}",
        src: require('../assets/signal-catch.svg'),
        style: {
          width: 58,
          height: 38
        }
      }), React.createElement("div", null, i18n['signalEvent'])), React.createElement(Panel, {
        header: i18n['end'],
        key: "5",
        forceRender: true
      }, React.createElement("img", {
        "data-item": "{clazz:'end',size:'30*30',label:''}",
        src: require('../assets/end.svg'),
        style: {
          width: 42,
          height: 42
        }
      }), React.createElement("div", null, i18n['endEvent'])))), React.createElement("div", {
        ref: this.pageRef,
        className: styles.canvasPanel,
        style: {
          width: isView ? '100%' : '70%',
          borderBottom: isView ? 0 : null
        }
      }), !isView && React.createElement("div", {
        ref: this.detailPanelRef,
        className: styles.detailPanel,
        style: {
          height: height
        }
      }, React.createElement(DetailPanel, {
        model: this.state.selectedModel,
        readOnly: readOnly,
        users: users,
        groups: groups,
        onChange: function onChange(key, val) {
          _this3.onItemCfgChange(key, val);
        }
      })))));
    }
  }]);

  return Designer;
}(Component);

Designer.defaultProps = {
  height: 500,
  isView: false,
  mode: 'edit',
  lang: 'zh'
};

export default Designer;
